
############################################################################# 
#                                                                           # 
#                      Modified filled contours                             # 
#                                                                           # 
############################################################################# 
.fcm<-function (x = seq(0, 1, len = nrow(z)), y = seq(0, 1, len = ncol(z)),z, xlim,ylim,zlim = range(z, finite = TRUE), nlevels = 20,levels = pretty(zlim, nlevels), col = color.palette(length(levels) -1), plot.title, legend=TRUE,omit.axes, plot.axes,key.title, key.axes, asp = NA,xaxs = "i", yaxs = "i", las = 1, axes = TRUE,overplot=FALSE,GUI=TRUE,...) { 
       
       if(omit.axes)asp<-1 
       if (missing(z)) { 
       if (!missing(x)) { 
           if (is.list(x)) { 
               z <- x$z 
               y <- x$y 
               x <- x$x 
           } 
           else { 
               z <- xx <- seq(0, 1, len = nrow(z)) 
           } 
       } 
       else stop("no `z' matrix specified") 
   } 
   else if (is.list(x)) { 
       y <- x$y 
       x <- x$x 
   } 
   if (any(diff(x) <= 0) || any(diff(y) <= 0))  
       stop("increasing x and y values expected") 
   mar.orig <- (par.orig <- par(c("mar", "las", "mfrow")))$mar 
   w <- (3 + mar.orig[2]) * par("csi") * 2.54 
   if(legend) layout(matrix(c(2, 1), nc = 2), widths = c(1,lcm(w))) 
   par(las = las) 
   mar <- mar.orig 
   mar[4] <- mar[2] 
   mar[2] <- 1 


if(legend){ 
   par(mar = mar) 
   plot.new() 
   plot.window(xlim = c(0, 1), ylim = range(levels), xaxs = "i",  
       yaxs = "i") 
   
   rect(0, levels[-length(levels)], 1, levels[-1], col = col) 
   if (missing(key.axes)) { 
       if (axes)  
           axis(4) 
   } 
   else key.axes 
   box() 
   if (!missing(key.title))  
       key.title 
   mar <- mar.orig 
   mar[4] <- 1 
} 
   par(mar = mar) 
   plot.new() 
   log<-paste("",sheet$demo$call$log,sep="") 
   plot.window(xlim, ylim, "", xaxs = xaxs, yaxs = yaxs, asp = asp,log = log) 
   if (!is.matrix(z) || nrow(z) <= 1 || ncol(z) <= 1)  
       stop("no proper `z' matrix specified") 
   if (!is.double(z)) storage.mode(z) <- "double" 
   #.Internal(filledcontour(as.double(x), as.double(y), z, as.double(levels),col = col)) 
   
   graphics::.filled.contour(as.double(x), as.double(y), z, as.double(levels),col = col) 

# For binary plots plot axes 
   if (!(omit.axes)) { 
       if (axes) { 
          title(main = "", xlab = "", ylab = "") 
           axis(1) 
           axis(2) 
           box() 
       } 
   } 
# For ternary plots do not plot axes, mask the area surrounding the triangle 
   else{ 
       polygon(x=c(-0.03,0,.5,1,1.05,1.05,-0.03,-0.03),y=c(0,0,sqrt(3)/2,0,0,1.03,1.03,0),col="white",border=NA) 
       polygon(x=c(-0.03,1.03,1.03,-0.03,-0.03),y=c(-0.1,-0.1,0,0,-0.1),col="white",border=NA) 
       rect(1.03,-0.1,1.05,1.05,col="white",fg="white",border=NA) 
   } 


# Plot Figaro template 
   .my.template(sheet$demo$template) 
   
   if(overplot){ 
               if(GUI) where<-selectSamples() else where<-names(x.data)
               x.data<-x.data[where] 
               y.data<-y.data[where] 
               points(x.data,y.data,pch=labels[where,"Symbol"],col=labels[where,"Colour"]) 
   } 
            
   if (missing(plot.title))  
       title(...) 
   else plot.title  
   invisible() 
   dev.set(dev.prev()) 
   figRedraw() 
} 

############################################################################# 
#                                                                           # 
#                             FILLED CONTOUR PLOT                           # 
#                                                                           # 
############################################################################# 
filledContourFig<-function(palette="heat.colors",grid.density=NULL,overplot=FALSE,xlab=sheet$demo$call$xlab,ylab=sheet$demo$call$ylab,xlim=sheet$demo$call$xlim,ylim=sheet$demo$call$ylim,annotate.fields=FALSE,...){ 
   on.exit(options("show.error.messages"=TRUE)) 
   
   #xlim=sheet$demo$call$xlim 
   #ylim=sheet$demo$call$ylim 
   
   omit.axes=(sheet$demo$call$axes==FALSE) # This is a ternary plot 
    
   if(length(omit.axes)==0)omit.axes<-FALSE 
   
   if(is.null(grid.density)){
        GUI<-TRUE 
        n<-winDialogString("Density of the grid (i.e., number of intervals per axis) ","20") 
        if(is.null(n)){cat("Cancelled.\n");options("show.error.messages"=FALSE);stop()} 
        grid.density<-as.numeric(n) 
   }else{
        GUI<-FALSE
   } 
   
   # Logarithmic plots
   log<-paste("",sheet$demo$call$log,sep="") 
   if(length(grep("x",log))==0){ 
       x.grid1<-seq(xlim[1],xlim[2],length=grid.density)  
       x.step<-(x.grid1[2]-x.grid1[1])/2 
       x.grid<-c(x.grid1,xlim[2]+2*x.step) 
       abline(v=x.grid,col="gray") 
       xx<-cut(x.data,x.grid) 
   }else{ 
       x.grid1<-seq(log10(xlim[1]),log10(xlim[2]),length=grid.density)  
       x.step<-(x.grid1[2]-x.grid1[1])/2 
       x.grid1<-10^x.grid1 
       x.grid<-c(x.grid1,xlim[2]+10^(2*x.step)) 
       abline(v=x.grid,col="gray") 
       xx<-cut(x.data,x.grid) 
   } 
    
   if(length(grep("y",log))==0){ 
       y.grid1<-seq(ylim[1],ylim[2],length=grid.density)   
       y.step<-(y.grid1[2]-y.grid1[1])/2 
       y.grid<-c(y.grid1,ylim[2]+2*y.step) 
       abline(h=y.grid,col="gray") 
       yy<-cut(y.data,y.grid) 
   }else{ 
       y.grid1<-seq(log10(ylim[1]),log10(ylim[2]),length=grid.density)  
       y.step<-(y.grid1[2]-y.grid1[1])/2 
       y.grid1<-10^y.grid1 
       y.grid<-c(y.grid1,ylim[2]+10^(2*y.step)) 
       abline(h=y.grid,col="gray") 
       yy<-cut(y.data,y.grid) 
   } 
    
   ee<-table(xx,yy)
 
   nlevels<-max(ee) 
    
   number<-as.character(ee) 
   number[number=="0"]<-"" 
        
   if(GUI){
        col<-selectPalette(nlevels,GUI=GUI) 
   }else{
        col<-selectPalette(nlevels,palette,GUI=GUI) 
   }
   
   if(rownames(col)!="terrain.colors"&rownames(col)!="topo.colors"){ 
       col<-rev(col) 
   } 
   
   if(length(grep("x",log))==0){ 
        x<-(x.grid1+x.step) 
         
    }else{ 
        x<-10^(log10(x.grid1)+x.step)     
    } 
     
    if(length(grep("y",log))==0){ 
        y<-(y.grid1+y.step) 
         
    }else{ 
        y<-10^(log10(y.grid1)+y.step)     
    } 
    text(rep(x, grid.density),rep(y,each=grid.density),number,col="darkgray") 
    
    if(GUI){
        over<-winDialog("Overplot?",type="yesno") 
        overplot<-(over=="YES") 
    }
    
    windows(width = 8, height = 6.5, pointsize = 10) 
    .fcm(x,y,ee,col=col,xlab=xlab,ylab=ylab,xlim=xlim,ylim=ylim,omit.axes=omit.axes,nlevels=nlevels,overplot=overplot,GUI=GUI) 
    if(annotate.fields){    
        abline(v=x.grid,lty="dashed",col="lightgreen") 
        abline(h=y.grid,lty="dashed",col="lightgreen") 
        ee[ee==0]<-"" 
        for(i in (1:length(y))){ 
            text(x,y[i],ee[,i],col="lightgreen") 
        } 
    } 
} 

############################################################################# 
#                                                                           # 
#                                  ADD CONTOURS                             # 
#                                                                           # 
############################################################################# 
.addContoursCore<-function(GUI=FALSE,bandwidth="auto",...){ 
   on.exit(options("show.error.messages"=TRUE)) 
   if(GUI){ 
       bandwidth<-winDialogString("Specify bandwidth - values 0.1-5 or 'auto'\n   (higher value corresponds to smoother result)","auto") 
       if(is.null(bandwidth)){cat("Cancelled.\n");options("show.error.messages"=FALSE);stop()} 
   } 
    
   x<-x.data[!is.na(x.data)&!is.na(y.data)] 
   y<-y.data[!is.na(x.data)&!is.na(y.data)] 
    
   if (bandwidth=="auto"){ 
       out<-kde2d(x,y, n = 100,lims=c(sheet$d$c$xlim,sheet$d$c$ylim)) 
   }else{ 
       out<-kde2d(x,y, h= rep(as.numeric(bandwidth),2),n = 100,lims=c(sheet$d$c$xlim,sheet$d$c$ylim)) 
   } 

   contour(out,add=TRUE,...) 
    
   #if (bandwidth=="auto") out<-contour(kde2d(x,y, n = 100,lims=c(sheet$d$c$xlim,sheet$d$c$ylim)),add=TRUE,...) 
   #else out<-contour(kde2d(x,y, h= rep(as.numeric(bandwidth),2),n = 100,lims=c(sheet$d$c$xlim,sheet$d$c$ylim)),add=TRUE,...) 
   invisible(out) 
} 

addContours<-function(GUI=FALSE,bandwidth="auto",...){ 
   on.exit(options("show.error.messages"=TRUE)) 
    
   if(screen(new=FALSE)){ 
       out<-lapply(1:length(plate.data),function(i){ 
           .getSlot(i,FALSE) 
           screen(i,new=FALSE) 
           get("sheet",.GlobalEnv) 
            
           #cat("Slot ",i,".\n",sep="") 
           #cat("Slot:",i," - ",as.character(sheet$d$c$ylab),"\n") 
           z<-.addContoursCore(GUI=GUI,bandwidth=bandwidth,...) 
           return(z) 
       }) 
   }else{ 
        out<-.addContoursCore(GUI=GUI,bandwidth=bandwidth,...) 
   } 
   invisible(out) 
} 





############################################################################# 
#                      Plots binary xy diagrams                             # 
#   with the size of the plotting symbols proportional to third variable (z)# 
############################################################################# 
plotWithCircles<-function(xaxis="",yaxis="",zaxis="",colour="heat.colors",scaling.factor=1,bins=NULL,ident=getOption("gcd.ident"),alpha="FF"){ 
   on.exit(options("show.error.messages"=TRUE)) 
    
   # If GUI, select samples and x axis 
   if(nchar(xaxis)==0) { 
       where<-selectSamples(print=(getOption("gcd.shut.up")==FALSE)) 
       xaxis<-selectColumnLabel(colnames(WR),message="x-axis, e.g. (SiO2+2.1)*TiO2/3\nor press ENTER to pick from a list",default="",sample.names=FALSE,silent=TRUE,empty.ok=FALSE) 
       GUI<-TRUE 
   }else{ 
       where<-rownames(WR) 
       GUI<-FALSE 
   } 
   if(getOption("gcd.shut.up")==FALSE) print(where) 
        
   # x data 
   if(!is.na(as.numeric(xaxis))){ 
       xaxis<-colnames(WR)[xaxis] 
       x.data<-WR[,xaxis] 
   }else{ 
       ee<-calcCore(xaxis) 
       x.data<-ee$results 
       xaxis<-ee$equation 
   } 

   # y axis 
   if(nchar(yaxis)==0) yaxis<-selectColumnLabel(colnames(WR),message="y-axis \n(press ENTER to pick from a list)",default="",sample.names=FALSE,silent=TRUE,print=FALSE,empty.ok=FALSE) 
   if(!is.na(as.numeric(yaxis))){ 
       yaxis<-colnames(WR)[yaxis] 
       y.data<-WR[,yaxis] 
   }else{ 
       ee<-calcCore(yaxis) 
       y.data<-ee$results 
       yaxis<-ee$equation 
   } 

   # z axis 
   if(nchar(zaxis)==0) zaxis<-selectColumnLabel(colnames(WR),message="circles represent \n(press ENTER to pick from a list)",default="",sample.names=FALSE,silent=TRUE,print=FALSE,empty.ok=FALSE) 
   if(!is.na(as.numeric(zaxis))){ 
       zaxis<-colnames(WR)[zaxis] 
       z.data<-WR[,zaxis] 
   }else{ 
       ee<-calcCore(zaxis) 
       z.data<-ee$results 
       zaxis<-ee$equation 
   } 

   #Get the data ready for selected samples 
   ee<-cbind(x.data,y.data,z.data) 
   ee<-ee[where,] 
   ii<-ee[apply(!is.na(ee),1,all),]    
   x.data<-ii[,1] 
   y.data<-ii[,2] 
   z.data<-ii[,3] 
    
   #if(min(z.data)<0)stop("Cannot handle negative data. Quitting...",call. = FALSE) 

   xmin<-min(x.data,na.rm=TRUE) 
   xmax<-max(x.data,na.rm=TRUE) 
   ymin<-min(y.data,na.rm=TRUE) 
   ymax<-max(y.data,na.rm=TRUE) 

   ee<-abs(xmax-xmin) 

   ff<-max(z.data,na.rm=TRUE)-min(z.data,na.rm=TRUE) 
   shift.z<-min(z.data,na.rm=TRUE) 
    
   #Scaling factor 
   if(GUI){ 
       #scaling.factor<-abs(round(ee/ff/30,7)) 
       scaling.factor<-as.numeric(winDialogString("scale circles by factor",as.character(scaling.factor))) 
       if(length(scaling.factor)==0){cat("Cancelled.\n");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
   }else{ 
       #if(is.null(scaling.factor)) scaling.factor<-abs(round(ee/ff/30,7)) 
   } 
    
   if(!is.null(bins)){     
       leg<-pretty(z.data,n=bins) 
   }else{ 
       leg<-pretty(z.data) 
   } 
    
   if(GUI){ 
       colour<-NULL 
   } 
       
   # Prepare colours, semitransparent if needed 
   nlevels<-length(leg)    
   col<-selectPalette(nlevels,colour) 
   col<-.transparencyInternational(col,alpha=alpha) 
    
   # Plot legend for z 
   windows(width = 9, height = 6, pointsize = 10,title=paste("Plot of",xaxis,"vs.",yaxis,"with circles representing",zaxis)) 
   nf <- layout(matrix(c(1,1,2,2,2,2,1,1,2,2,2,2), 2,6,byrow=TRUE)) 
   layout.show(nf)    
   plot(0,0,xlim=c(0,1),ylim=c(0,1),type="n",xlab="",ylab="",axes=FALSE,main=annotate(zaxis),cex.main=2) 
    
   #ystep<-(ymax-ymin)/(nlevels+1) 
   ystep<-1/(nlevels+1) 
   symbols(rep(2/9,nlevels-1),1-(1:(length(leg)-1)*ystep),circles=(leg[1:(nlevels-1)]-shift.z+(leg[2]-leg[1])*8)*scaling.factor,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=0.15,cex.main=1.8,add=TRUE) 
   symbols(rep(4/9,nlevels-1),1-(1:(length(leg)-1)*ystep),circles=(leg[-1]-shift.z+(leg[2]-leg[1])*10)*scaling.factor,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=0.15,cex.main=1.8,add=TRUE) 
   
   #symbols(rep((xmin+xmax)/3-5,nlevels-1),ymax-(1:(length(leg)-1)*ystep),circles=(leg[1:(nlevels-1)]-shift.z+(leg[2]-leg[1])*8)*scaling.factor,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=0.15,cex.main=1.8) 
   #symbols(rep(2*(xmin+xmax)/3,nlevels-1),ymax-(1:(length(leg)-1)*ystep),circles=(leg[-1]-shift.z+(leg[2]-leg[1])*10)*scaling.factor,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=0.15,cex.main=1.8,add=TRUE) 
  
   #symbols(rep((xmin+xmax)/2,nlevels-1),ymax-(1:(length(leg)-1)*ystep),circles=(leg[-1]-shift.z)*scaling.factor*2.25,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=FALSE,cex.main=1.8) 
    
   legenda<- paste(": ",as.character(leg)[2:length(leg)-1],"\u2013",as.character(leg)[2:length(leg)])
   box() 
   text(rep(1/3,length(legenda)),1-(1:length(legenda)*ystep),"",cex=1.5) 
   text(rep(6/9,length(legenda)),1-(1:length(legenda)*ystep),legenda,cex=1.5,adj=0.5) 
   #text(rep(xmax-(xmax-xmin)/5,length(legenda)),ymax-(1:length(legenda)*ystep),legenda,cex=1.5) 

   # Plot the diagram 
   par("mar"=c(5,5,4,3)) 
   symbols(x.data, y.data, circles=(z.data-shift.z+(leg[2]-leg[1])*8)*scaling.factor,xlim=c(xmin,xmax),ylim=c(ymin,ymax),inches=0.15, bg = col[findInterval(z.data,leg,rightmost.closed=TRUE)],fg="gray30",xlab=annotate(xaxis),ylab=annotate(yaxis),cex.axis=1.3,cex.lab=1.3,add=FALSE) 
   #symbols(x.data, y.data, circles=(z.data-shift.z)*scaling.factor,xlim=c(xmin,xmax),ylim=c(ymin,ymax),inches=FALSE, bg = col[findInterval(z.data,leg,rightmost.closed=TRUE)],fg="gray30",xlab=annotate(xaxis),ylab=annotate(yaxis),cex.axis=1.3,cex.lab=1.3) 
   if(ident)ee<-ID(x.data,y.data,col="black") 
   palette(as.vector(palette.gcdkit)) 
   figaroOff() 
   invisible() 
} 

############################################################################# 
#                   Plots templates for binary diagrams                     # 
#   with the size of the plotting symbols proportional to third variable (z)# 
############################################################################# 
# diagramWithCircles("PeceTaylor","SiO2") 
# colour is name of palette or vector specifying colour for each of the samples 
# if diagram=NULL and not GUI, current template in  memory is used 

diagramWithCircles<-function(zaxis="",diagram=NULL,colour="heat.colors",scaling.factor=1,bins=NULL,ident=getOption("gcd.ident"),alpha="FF"){ 
   on.exit(options("show.error.messages"=TRUE)) 
   
   # If z axis is empty, it is GUI 
   if(nchar(zaxis)==0){ 
       GUI<-TRUE
   }else{ 
       GUI<-FALSE 
   } 
   
   # The Figaro template 
   if(is.null(diagram)){ 
       if(GUI){ 
           .switch.classification() 
       }else{ 
           figRedraw() 
       } 
   }else{  
       shutup.bak<-options("gcd.shut.up") 
       options("gcd.shut.up"=TRUE) 
       prd<-plotDiagram(diagram,select.samples=FALSE) 
       dev.off(dev.cur()) 
       options("gcd.shut.up"=shutup.bak) 
   } 
   
   # If GUI, select z axis 
   if(GUI){ 
       zaxis<-selectColumnLabel(colnames(WR),message="circles represent \n(press ENTER to pick from a list)",default="",sample.names=FALSE,silent=TRUE,print=FALSE,empty.ok=FALSE) 
   }else{ 
       where<-rownames(WR)
   } 
    
   if(!is.na(as.numeric(zaxis))){ 
       zaxis<-colnames(WR)[zaxis] 
       z.data<-WR[,zaxis] 
   }else{ 
       ee<-calcCore(zaxis) 
       z.data<-ee$results 
       zaxis<-ee$equation 
   } 
    
   # Get ready the data for selected samples 
   ee<-cbind(x.data,y.data,z.data) 
   where<-names(x.data) 
   ee<-ee[where,] 
   ii<-ee[apply(!is.na(ee),1,all),]    
   x.data<-ii[,1] 
   y.data<-ii[,2] 
   z.data<-ii[,3] 

   xmin<-min(x.data,na.rm=TRUE) 
   xmax<-max(x.data,na.rm=TRUE) 
   ymin<-min(y.data,na.rm=TRUE) 
   ymax<-max(y.data,na.rm=TRUE) 

   # ee<-abs(xmax-xmin) 

   # ff<-max(z.data,na.rm=TRUE)-min(z.data,na.rm=TRUE) 
    
   # Affects minimal plot symbol size  
   shift.z<-min(z.data,na.rm=TRUE) 
    
   # Scaling factor 
   if(GUI){ 
       #scaling.factor<-abs(round(ee/ff/30,7)) 
       scaling.factor<-as.numeric(winDialogString("scale circles by factor",as.character(scaling.factor))) 
       if(length(scaling.factor)==0){cat("Cancelled.\n");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
   }else{ 
       #if(is.null(scaling.factor)) scaling.factor<-abs(round(ff/30,7)) 
   }    
    
   if(is.character(colour)&length(colour)==1){ 
       colPredefined<-FALSE 
   }else{ 
       colPredefined<-TRUE 
   } 
    
   if(colPredefined){ 
       get("leg.col",.GlobalEnv) 
       prd<-gsub("(^[-]?[\\.0-9]+)(-)?([-]?[\\.0-9]+)","\\1@\\3",colnames(leg.col)) 
       leg<-unlist(strsplit(prd,"@")) 
       leg<-unique(as.numeric(leg)) 
   }else{ 
       if(!is.null(bins)){     
           leg<-pretty(z.data,n=bins) 
       }else{ 
           leg<-pretty(z.data) 
       } 
   } 
    
   nlevels<-length(leg)  
   if(GUI){ 
       colour<-NULL 
       col<-selectPalette(nlevels,colour) 
       col<-.transparencyInternational(col,alpha=alpha) 
   }else{ 
       # Prepare colours, semitransparent if needed 
       if(!colPredefined){   
           col<-selectPalette(nlevels,colour) 
           col<-.transparencyInternational(col,alpha=alpha) 
       }else{ 
           col<-leg.col 
       } 
   } 
    
    
   # Deeval axes 
   xaxis<-.fig.deeval(sheet$d$c$xlab) 
   yaxis<-.fig.deeval(sheet$d$c$ylab) 
    
   # Plot legend for z 
   windows(width = 9, height = 6, pointsize = 10,title=paste("Plot of",xaxis,"vs.",yaxis,"with circles representing",zaxis)) 
   nf <- layout(matrix(c(1,1,2,2,2,2,1,1,2,2,2,2), 2,6,byrow=TRUE)) 
   layout.show(nf) 

       plot(0,0,xlim=c(0,1),ylim=c(0,1),type="n",xlab="",ylab="",axes=FALSE,main=annotate(zaxis),cex.main=2) 
    
       #ystep<-(ymax-ymin)/(nlevels+1) 
       ystep<-1/(nlevels+1) 
       symbols(rep(2/9,nlevels-1),1-(1:(length(leg)-1)*ystep),circles=(leg[1:(nlevels-1)]-shift.z+(leg[2]-leg[1])*8)*scaling.factor,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=0.15,cex.main=1.8,add=TRUE) 
       symbols(rep(4/9,nlevels-1),1-(1:(length(leg)-1)*ystep),circles=(leg[-1]-shift.z+(leg[2]-leg[1])*10)*scaling.factor,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=0.15,cex.main=1.8,add=TRUE) 
       #symbols(rep(2*(xmin+xmax)/9,nlevels-1),ymax-(1:(length(leg)-1)*ystep),circles=(leg[1:(nlevels-1)]-shift.z+(leg[2]-leg[1])*8)*scaling.factor,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=0.15,cex.main=1.8) 
       #symbols(rep(4*(xmin+xmax)/9,nlevels-1),ymax-(1:(length(leg)-1)*ystep),circles=(leg[-1]-shift.z+(leg[2]-leg[1])*10)*scaling.factor,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=0.15,cex.main=1.8,add=TRUE) 
    
       legenda<- paste("= ",as.character(leg)[2:length(leg)-1],"-",as.character(leg)[2:length(leg)]) 
       box() 
       text(rep(1/3,length(legenda)),1-(1:length(legenda)*ystep),"",cex=1.5) 
       text(rep(6/9,length(legenda)),1-(1:length(legenda)*ystep),legenda,cex=1.5) 
       #text(rep(xmax-(xmax-xmin)/5,length(legenda)),ymax-(1:length(legenda)*ystep),legenda,cex=1.5) 
    
    
   # Plot the diagram 
   sheet$demo$call$cex<-rep(0,length(x.data)) 
   assign("sheet", sheet, .GlobalEnv) 
   pp <<- figaro(demo, prefix = "sheet") 
   figRedraw() 
    
   # and also circles 
   symbols(x.data, y.data, circles=(z.data-shift.z+(leg[2]-leg[1])*8)*scaling.factor,xlim=c(xmin,xmax),ylim=c(ymin,ymax),inches=0.15, bg = col[findInterval(z.data,leg,rightmost.closed=TRUE)],fg="gray30",xlab=annotate(xaxis),ylab=annotate(yaxis),cex.axis=1.3,cex.lab=1.3,add=TRUE) 
   #symbols(x.data, y.data, circles=(z.data-shift.z)*scaling.factor,xlim=c(xmin,xmax),ylim=c(ymin,ymax),inches=0.15, bg = col[findInterval(z.data,leg,rightmost.closed=TRUE)],fg="gray30",xlab=annotate(xaxis),ylab=annotate(yaxis),cex.axis=1.3,cex.lab=1.3,add=TRUE) 
   if(ident)ee<-ID(x.data,y.data,col="black") 
   palette(as.vector(palette.gcdkit)) 
   figaroOff() 
   invisible() 
} 

# Assigns to each level of x the most frequently used colour (character or numeric) 
.getAvgColour<-function(x=NULL){ 
   if(!is.null(x)){    # Groups reqd 
       ii<-factor(x) 
   }else{              # The whole dataset 
       x<-"All" 
       ii<-factor(rep(x,nrow(labels))) 
   } 
    
   ee<-tapply(factor(labels$Colour),ii,table) 
   if(length(unlist(ee))==1){ 
       col<-labels$Colour[1] 
   }else{ 
       col<-lapply(levels(factor(x)),function(i){ 
           z<-names(which(ee[[i]]==max(ee[[i]]))) 
           return(z) 
       }) 
       col<-unlist(col)  
   } 
   if(is.numeric(labels$Colour)) col<-as.numeric(col) 
   col<-col[1:length(levels(ii))] 
   col<-as.vector(col) 
   names(col)<-levels(ii) 
   return(col) 
} 

############################################################################# 
#                                                                           # 
#                    Convex hull, the whole dataset                         # 
#                                                                           # 
############################################################################# 

chullAll<-function(border=NULL,fill=FALSE,...){ 
   on.exit(options("show.error.messages"=TRUE)) 
    
   # Setup the colours 
   if(is.null(border)){ 
       border<-.getAvgColour() 
   } 
    
   if(fill) fill<-border else fill<-NA 
   names(border)<-filename 
    
   xx<-x.data 
   yy<-y.data 
   xx<-xx[!is.na(xx)&!is.na(yy)] 
   yy<-yy[!is.na(xx)&!is.na(yy)] 
   ee<-chull(xx,yy) 
   ee<-names(xx)[ee] 
   which<-c(ee,ee[1]) 
   polygon(xx[which],yy[which],col=fill,border=border,...) 
    
   if(!is.na(fill)) points(x.data,y.data,pch=labels[names(x.data),"Symbol"],col="black",cex=labels[names(x.data),"Size"]) 
   invisible() 
} 
############################################################################# 
#                                                                           # 
#                   Convex hull, by groups as default                       # 
#                                                                           # 
############################################################################# 
 
chullGroups<-function(clusters=groups,border=NULL,fill=FALSE,...){ 
   on.exit(options("show.error.messages"=TRUE)) 
   if(is.numeric(clusters)){ 
       winDialog(type="ok",paste("clusters not defined!")) 
       return() 
   } 
    
   # Setup the colours 
   if(is.null(border)){ 
       border<-.getAvgColour(clusters) 
   }else{ 
       if(length(border)!=length(levels(factor(clusters)))) border<-rep(border,times=length(levels(factor(clusters)))) 
       names(border)<-levels(factor(clusters)) 
   } 
    
   if(fill) fill<-border else fill<-NA 
   ee<-lapply(levels(factor(clusters)),function(i){ 
       xx<-x.data[clusters==i] 
       yy<-y.data[clusters==i] 
       xx<-xx[!is.na(xx)&!is.na(yy)] 
       yy<-yy[!is.na(xx)&!is.na(yy)] 
       ee<-chull(xx,yy) 
       ee<-names(xx)[ee] 
       which<-c(ee,ee[1]) 
       polygon(xx[which],yy[which],col=fill[i],border=border[i],...) 
   }) 
   if(!is.na(fill)) points(x.data,y.data,pch=labels[names(x.data),"Symbol"],col="black",cex=labels[names(x.data),"Size"]) 
   invisible() 
} 

# "horizontal" slices of KDE, for constant values of the pdf 
# Test how much is above the curve for given z values
.getContourKDE<-function(z,kdemat,xy.grid,desired.number){
    .propUnderPdf<-function(z,kdemat){
        indie<-which(kdemat>=z,arr.ind=TRUE)
        out<-sum(xy.grid[indie])
        return(out)
    }
    foo<-function(z){
        return(abs(.propUnderPdf(z,kdemat)-desired.number))
    }
    out<-optimize(foo,range(kdemat),tol=range(kdemat)/20)$minimum
    return(out)
}

.fadeAway<-function(col,transp){
    alpha1<-transp
    alpha1<-as.hexmode(floor(alpha1*255)) 
    alpha<-format(alpha1,width=2,upper.case=TRUE) 
    col<-col2rgb(col)
    col<-paste(as.hexmode(col),collapse="")
    col<-paste("#",toupper(col),sep="") 
    col<-.transparencyInternational(col,alpha=alpha)
    return(col)
}
          
############################################################################# 
#                                                                           # 
#                      Contours, the whole dataset                         # 
#                                                                           # 
############################################################################# 

contourAll<-function(cont.levels=c(0.25,0.50,0.75), n = 20, border = NULL, fill = FALSE, fade.away = TRUE,...){  
  on.exit(options("show.error.messages"=TRUE)) 
  output<-contourGroups(clusters = rep("All",times=nrow(WR)),cont.levels=cont.levels, n = n, border = border, fill = fill, fade.away = fade.away,...)  
  invisible(output) 
} 

############################################################################# 
#                                                                           # 
#                     Contours, by groups as default                        # 
#                                                                           # 
############################################################################# 
# Draw contour lines roughly corresponding to percentile of dataset
contourGroups<-function(clusters = groups, cont.levels=c(0.25,0.50,0.75), n = 20, border = NULL, fill = FALSE, fade.away = TRUE,...){ 
   on.exit(options("show.error.messages"=TRUE)) 
   if(is.numeric(clusters)){ 
       winDialog(type="ok",paste("clusters not defined!")) 
       return() 
   } 
    
   # Setup the labels for clusters 
   labs<-as.character(levels(factor(clusters))) 
   labs<-abbreviate(labs,minlength = 5)
   gr<-abbreviate(clusters,minlength = 5) 
    
   # Setup the colours 
   if(is.null(border)){ 
       border<-.getAvgColour(clusters) 
   }else{ 
       if(length(border)!=length(levels(factor(clusters)))) border<-rep(border,times=length(levels(factor(clusters)))) 
       names(border)<-levels(factor(clusters)) 
   } 
   names(border)<-labs
   
   # ranges and steps of axes
   xrange<-sheet$d$c$xlim
   yrange<-sheet$d$c$ylim
   dx<-(xrange[2]-xrange[1])/n
   dy<-(yrange[2]-yrange[1])/n
   
   
   output<-sapply(labs,function(i){ 
       xx<-x.data[gr==i] 
       yy<-y.data[gr==i] 
       xx<-xx[!is.na(xx)&!is.na(yy)] 
       yy<-yy[!is.na(xx)&!is.na(yy)] 
        
       if(length(xx)>0&length(yy)>0){ 
            picked<-intersect(names(xx),names(yy)) # Pick only points for which there are both x and y coordinates available 
            kderes<<-MASS::kde2d(xx[picked],yy[picked], 
            h=c(MASS::bandwidth.nrd(xx[picked]), MASS::bandwidth.nrd(yy[picked])),
            n = n, lims = c(xrange, yrange)) 
            
            #names(kderes)[1]<-.fig.deeval(sheet$d$c$xlab)
            #names(kderes)[2]<-.fig.deeval(sheet$d$c$ylab)
            
            # Classify all the real data for the given group into the grid
            xbins<-seq(from=xrange[1],to=xrange[2],by=dx)
            ybins<-seq(from=yrange[1],to=yrange[2],by=dy)
            x.class<-cut(xx[picked],xbins)
            y.class<-cut(yy[picked],ybins)
            xy.grid<-table(x.class,y.class)
            
            # print(xy.grid)
            # grid(n,n)
            # persp(kderes)

            # Number of points desired
            pts<-ceiling(length(picked)*cont.levels)
            names(pts)<-cont.levels
            cat(i,"- number of points: \n")
            print(pts)
            res<-NULL
            
            out<-sapply(cont.levels,function(cv){
                ee<-.getContourKDE(z,kderes$z,xy.grid,length(picked)*cv)
                
                # Plotting for debugging
                #zz<-seq(0,0.002,by=0.000005)
                #yyyy<-sapply(zz,function(i){
                #    out<-foo(i)
                #})
                
                 #windows()
                 #plot(zz,yyyy,main=paste(i,":",cv),xlim=range(kderes$z),ylim=c(0,length(picked)*cv))
                 #abline(h=length(picked)*cv)
                 #abline(v=ee)
                names(ee)<-cv
                res<-c(res,ee)
                
                # setup the colour transparency, of reqd
                if(fade.away){
                    col<-.fadeAway(col=border[i],transp=1-cv+0.1)
                }else{
                    col<-border[i]
                }
                contour(kderes[[1]],kderes[[2]],kderes[[3]],levels=ee,add=TRUE,labels=paste(cv*100,"%"),lwd=2,col=col,...)
                return(res)
            },simplify=TRUE)
            text(median(xx[picked]),median(yy[picked]),i)
            return(list(z=out,kde=kderes))
       } 
    },simplify=FALSE)
  invisible(output)
}

############################################################################# 
#                                                                           # 
#                             Strip Boxplot                                 # 
#                                                                           # 
############################################################################# 

stripBoxplot<-function(yaxis="", zaxis="0", ymin=NULL, ymax=NULL, pal="heat.colors", transp=0, ident=FALSE, scaling.factor=NULL, boxplot.data=NULL, pch=NULL, col=NULL, cex=NULL, sample.names=FALSE, labs=TRUE, horizontal=FALSE, silent=TRUE, add=FALSE){ 
   on.exit(options("show.error.messages"=TRUE)) 
   
   if(is.null(pch)){ 
       pch<-labels[,"Symbol"] 
       names(pch)<-rownames(labels) 
   }else{ 
       if(length(pch)==1) pch<-rep(pch,nrow(labels)) 
       if(is.null(names(pch))) names(pch)<-rownames(labels) 
   } 
    
   if(is.null(col)){ 
       col<-labels[,"Colour"] 
       names(col)<-rownames(labels) 
   }else{ 
       if(length(col)==1) col<-rep(col,nrow(labels)) 
       if(is.null(names(col))) names(col)<-rownames(labels) 
   } 
    
    if(is.null(cex)){ 
       cex<-labels[,"Size"] 
       names(cex)<-rownames(labels) 
   }else{ 
       if(length(cex)==1) cex<-rep(cex,nrow(labels)) 
       if(is.null(names(cex))) names(cex)<-rownames(labels) 
   } 
    
   if(is.numeric(groups)){ 
       winDialog(type="ok",paste("Groups not defined!")) 
       return() 
   } 
    
   if(!silent){ 
       if(nchar(yaxis)==0) yaxis<-selectColumnLabel(colnames(WR),message="Select variable... \n(press ENTER to pick from a list)",default="",sample.names=FALSE,silent=TRUE,print=FALSE,empty.ok=FALSE) 
   } 
       if(!is.na(as.numeric(yaxis))){ 
           yaxis<-colnames(WR)[yaxis] 
           y.data<-WR[,yaxis] 
       }else{ 
           ee<-calcCore(yaxis) 
           y.data<-ee$results 
           yaxis<-ee$equation 
       } 
   if(!silent){ 
       if(zaxis=="0") zaxis<-selectColumnLabel(colnames(WR),message="circles represent \n(0 - nothing, press ENTER to pick from a list)",default="0",sample.names=FALSE,silent=TRUE,print=FALSE,empty.ok=FALSE) 
   } 
    
   if(zaxis!="0"){ 
       if(!is.na(as.numeric(zaxis))){ 
           zaxis<-colnames(WR)[zaxis] 
           z.data<-WR[,zaxis] 
       }else{ 
           ee<-calcCore(zaxis) 
           z.data<-ee$results 
           zaxis<-ee$equation 
       } 
       ee<-cbind(y.data,z.data) 

       #where<-selectSamples() 
       #ee<-ee[where,] 
       ii<-ee[apply(!is.na(ee),1,all),] 


       y.data<-ii[,1] 
       z.data<-ii[,2] 
   } 
   
   if(is.null(ymin)) ymin<-min(y.data,na.rm=TRUE) 
   if(is.null(ymax)) ymax<-max(y.data,na.rm=TRUE)  
    
   if(!is.factor(groups)){ 
       x.data<-factor(groups[names(y.data)],ordered=TRUE) 
   }else{ 
       if(!is.null(names(groups))){ 
           x.data<-groups[names(y.data)] 
       }else{ 
           x.data<-groups 
           names(x.data)<-rownames(labels) 
       } 
       x.data<-x.data[names(y.data)] 
   } 
    
   xmin<-1 
   xmax<-length(levels(x.data)) 
   ee<-abs(xmax-xmin) 
    
   if(zaxis!="0"){     
       ff<-max(z.data,na.rm=TRUE)-min(z.data,na.rm=TRUE) 
       shift.z<-min(z.data,na.rm=TRUE) 
       scaling.factor<-abs(round(ee/ff/40,7)) # Was commented off 
       if(!silent|!is.null(scaling.factor)){ 
           scaling.factor<-abs(round(ee/ff/40,7)) 
       } 
        
       if(!silent){ 
           scaling.factor<-as.numeric(winDialogString("scale circles by factor",as.character(scaling.factor))) 
           if(length(scaling.factor)==0){cat("Cancelled.\n");options("show.error.messages"=FALSE);stop()} 
       } 
        
       leg<-pretty(z.data,n=10) 
       nlevels<-length(leg) 
             
       #if(!silent){ 
       #    col<-selectPalette(nlevels,pal) 
           #col<-selectPalette(nlevels) 
       #}else{ 
       #    col<-selectPalette(nlevels,pal) 
       #} 
        
       # Colours and possible transparency 
       col.in<-selectPalette(nlevels,pal) 

       # Test for valid transparency value 
       if(is.na(transp)){winDialog(type="ok","Invalid input!\nTransparency has to be numeric.");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
       if(transp>1|transp<0){winDialog(type="ok","Out of bounds!\nTransparency has to be 0-1.");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
        
       # Set alpha value 
       alpha1<-1-transp 
       alpha1<-as.hexmode(floor(alpha1*255)) 
       alpha<-format(alpha1,width=2,upper.case=TRUE) 
       col<-.transparencyInternational(col.in,alpha=toupper(alpha)) 
        
       # Plot legend for z 
       windows(width = 12, height = 6, pointsize = 14) 
       nf <- layout(matrix(c(1,1,2,2,2,2,1,1,2,2,2,2),2,6,byrow=TRUE)) 
       layout.show(nf) 

       ystep<-(ymax-ymin)/(nlevels+1) 
       
       symbols(rep(1.5,nlevels-1),ymax-(1:(length(leg)-1)*ystep),circles=(leg[-1]-shift.z)*scaling.factor*2.25+0.05,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=FALSE,cex.main=1.5) 
       #symbols(rep((xmin+xmax)/2,nlevels-1),ymax-(1:(length(leg)-1)*ystep),circles=(leg[-1]-shift.z)*scaling.factor*2.25+0.05,axes=FALSE,xlim=c(xmin,xmax),ylim=c(ymin,ymax),xlab="",ylab="",main=annotate(zaxis),bg = col,fg="gray30",inches=FALSE,cex.main=1.5) 
       legenda<- paste(as.character(leg)[2:length(leg)-1],"-",as.character(leg)[2:length(leg)]) 
       box() 
       text(rep((xmin+xmax)/2,length(legenda)),ymax-(1:length(legenda)*ystep),legenda,cex=1.3) 
       #text(rep(xmax-(xmax-xmin)/5,length(legenda)),ymax-(1:length(legenda)*ystep),legenda,cex=1.3) 
        
   }else{ # no second variable specified 
       if(!add)windows(width = 9, height = 6, pointsize = 12) 
   } 
    
   
   # Plot the diagram 
    
   # Boxplot 
   if(add) minlength<-5 else minlength<-10 
   
   if(is.null(boxplot.data)){ 
       if(labs) lbs<-abbreviate(levels(x.data),minlength=minlength,dot=TRUE) else lbs<-rep("",length(levels(x.data))) 
       at<-1:length(levels(x.data))  
        
       # Alternating axis labels 
       odd<-seq(1,length(at),by=2) 
       even<-seq(2,length(at),by=2) 
        
       if(horizontal){ 
           ee<-boxplot(y.data~x.data,ylim=c(ymin,ymax),border="grey",col="lightgrey",boxwex=0.8,names=rep("",length(at)),xlab=annotate(yaxis),cex.axis=1,cex.lab=1.1,outline=FALSE,las=1,ylab="",horizontal=horizontal)  
           mtext(side=2,at=at[even],text=lbs[even],cex=0.75,line=-0.3,adj=0.5,padj=1) 
           mtext(side=2,at=at[odd],text=lbs[odd],cex=0.75,line=-1.5,adj=0.5,padj=0) 
           abline(v=0) 
       }else{ 
           ee<-boxplot(y.data~x.data,ylim=c(ymin,ymax),border="grey",col="lightgrey",boxwex=0.8,names=rep("",length(at)),ylab=annotate(yaxis),cex.axis=1,cex.lab=1.1,outline=FALSE,las=1,xlab="",horizontal=horizontal)  
           mtext(side=1,at=at[even],text=lbs[even],cex=0.75,line=-0.3,adj=0.5,padj=1) 
           mtext(side=1,at=at[odd],text=lbs[odd],cex=0.75,line=-1.5,adj=0.5,padj=0) 
           abline(h=0) 
       } 
   }else{ 
       names(boxplot.data)<-abbreviate(levels(x.data),minlength=minlength,dot=TRUE) 
       ee<-boxplot(boxplot.data,ylim=c(ymin,ymax),border="grey",col="lightgrey",boxwex=0.5,xlab="",ylab="",main=annotate(yaxis),cex.axis=1,cex.lab=1.1,outline=FALSE,xlab="")  
   } 
             
   # Overlying stripplots 
   y<-unlist(split(y.data,x.data)) 
    
   x.data<-sort(x.data) 
   x<-jitter(as.numeric(x.data),0.5) 
    
   if(zaxis!="0"){ 
       z<-z.data[names(x.data)] 
       symbols(x, y, circles=(z-shift.z)*scaling.factor+0.05,ylim=c(ymin,ymax),inches=FALSE, bg = col[findInterval(z,leg,rightmost.closed=TRUE)],fg="gray30",ylab=annotate(yaxis),yaxs="i",add=TRUE) 
       palette(as.vector(palette.gcdkit)) 
   }else{ 
       if(horizontal){ 
          points(y, x, ylim=c(ymin,ymax),pch=pch[names(x.data)],col=col[names(x.data)],cex=cex[names(x.data)],xlab=annotate(yaxis)) 
       }else{ 
          points(x, y, xlim=c(ymin,ymax),pch=pch[names(x.data)],col=col[names(x.data)],cex=cex[names(x.data)],ylab=annotate(yaxis)) 
          #points(x, y, ylim=c(ymin,ymax),pch=labels[names(x.data),"Symbol"],col=labels[names(x.data),"Colour"],cex=labels[names(x.data),"Size"],ylab=annotate(yaxis)) 
       } 
   } 
    
   # Show sample names? 
   if((sample.names)) text(x,y,names(x.data),pos=4)  
    
   # Identify? 
   if(getOption("gcd.ident")|ident){ 
       if(horizontal){ 
           ee<-ID(y,x,labs=names(x.data),col="black") 
       }else{ 
           ee<-ID(x,y,labs=names(x.data),col="black") 
       } 
   } 
    
   names(x)<-names(x.data) 
   names(y)<-names(y.data) 
    
   if(horizontal){ 
       assign("x.data",y,.GlobalEnv) 
       assign("y.data",x,.GlobalEnv) 
   }else{ 
       assign("x.data",x,.GlobalEnv) 
       assign("y.data",y,.GlobalEnv) 
   } 
   invisible() 
} 


# Still to do for integration to system - legend 
# what is variable name or formula 
# pal palette 
# save: if true, labels$Colours are also superassigned 

assignColVar<-function(what=NULL,pal="heat.colours",save=TRUE,n=15,range=NULL,quant=0,eq.classes=FALSE,alt.leg=FALSE){ 
   on.exit(options("show.error.messages"=TRUE)) 
   options(show.error.messages=TRUE) 
   
   # Batch mode or GUI? 
   if(!is.null(what)) GUI<-FALSE else GUI<-TRUE 
    
   # Check range (if any) 
   if(!is.null(range)){ 
       if(!is.numeric(range)|length(range)!=2){ 
           range<-NULL 
       }else{ 
           range<-sort(range) 
       } 
   } 
    
   # Check that quant is 0 to 50 
   if(quant<0 | quant>50) {cat("Invalid quant value (must be 0-50)! Quitting...\n");stop(call. = TRUE)} # NEW BY VJ 
    
   # Colours 
   if(GUI){ 
       what<-selectColumnLabel(colnames(WR),message="Colours represent \n(press ENTER to pick from a list)",default="",sample.names=FALSE,silent=TRUE,print=FALSE,empty.ok=FALSE) 
       if(is.numeric(what)) what<-colnames(WR)[what] 
   } 
    
   # Property 
   if(!is.na(as.numeric(what))){ 
       zaxis<-colnames(WR)[what] 
       z.data<-WR[,what] 
   }else{ 
       ee<-calcCore(what) 
       z.data<-ee$results 
       zaxis<-ee$equation 
   } 
    
   if(GUI){ 
       n<-winDialogString("Desired approximate number of intervals",as.character(n)) 
       if(is.null(n)){cat("Cancelled.\n");stop(call. = TRUE)} 
       if(is.na(as.numeric(n))){winDialog("ok","Non-numeric value!");stop(call. = TRUE)} 
       n<-as.numeric(n) 
   } 
    
   # This block trims the interval to the (quant, 1-quant)-th quantile of the dataset 
   # This helps to take care of outliers     
    if(GUI){ 
       quant<-winDialogString("Trim the data to n-th quantile?\nEnter a single value between 0 and 100...","0") 
       if(is.null(quant)){cat("Cancelled.\n");stop(call. = TRUE)} 
       if(is.na(as.numeric(quant))) {winDialog("ok","Non-numeric value!");stop(call. = TRUE)} 
       quant<-as.numeric(quant)         
       if(quant<0 | quant>50) {winDialog("ok","Invalid value!");stop(call. = TRUE)} # NEW BY VJ 
   } 
   zmin<-quantile(z.data,quant/100,na.rm=TRUE)    
   zmax<-quantile(z.data,1-quant/100,na.rm=TRUE)  
    
   # Nothing left (only if quant=50 and we have even number of samples 
   options(show.error.messages=FALSE) 
   if(zmin==zmax) {cat("No matches! Quitting...\n");stop(call. = FALSE)} # NEW BY VJ 
    
   if(is.null(range)){ 
       zz<-range(subset(z.data,z.data>=zmin&z.data<=zmax))  
   }else{ 
       zz<-range 
   } 
    
   # There are two ways to cut the colour scale, by quantiles or in regular increments 
   if(GUI){ 
       x<-winDialog("Make the intervals of the same width\n(rather than to contain equal numbers of values)?",type="yesno") 
       if(is.null(x)){cat("Cancelled.\n");stop(call. = TRUE)} 
       eq.classes<-(x=="NO") 
   } 

   if(eq.classes){ 
       brk<-pretty(c(0,1),n) # Pretty intervals containing the same numbers of observations (based on probabilitities, step by 20%) 
       leg.levels<-unique(quantile(z.data[z.data>zmin&z.data<zmax],brk,na.rm=TRUE)) 
   }else{ 
       leg.levels <- pretty(zz, n = n + 1) # Pretty intervals of the same width in wt. % etc 
   } 
    
   # NEW BY VJ, PROBABLY JUNK 
   #if(quant!=0){            
   #    dec.places<-nchar(gsub("^[0-9]{1,}[.]?", "",abs(max(leg.levels,na.rm=TRUE,finite=TRUE)))) 
   #    leg.levels[1]<-.round.min.down(zz[1],dec.places) 
   #    leg.levels[length(leg.levels)]<-.round.max.up(zz[2],dec.places) 
   #    leg.levels<-unique(leg.levels) 
   #} # \VJ 
       
   nlevels<-length(leg.levels)-1 
    
   if(GUI){ 
       colour.palette<-NULL 
   } 

   if(GUI){ 
       pal<-selectPalette(nlevels) 
   }else{ 
       pal<-selectPalette(nlevels,pal) 
   } 

   col<-as.character(cut(z.data,leg.levels,pal,include.lowest=TRUE)) 
   col[z.data<zmin]<-NA   
   col[z.data>zmax]<-NA 
    
   col[is.na(col)]<-"gray" 
    
   if(save){ 
       labels[,"Colour"]<-col 
       .assignWithNamespaceHard("labels",labels) 
   } 
    
   leg<-pal
   
   plac<-15
   while(length(leg.levels)==length(unique(round(leg.levels,plac)))){
        plac<-plac-1
   }
   
   #labs<-formatC(leg.levels,digits=plac+1,format="f")
   labs<-prettyNum(leg.levels)
   colnames(leg)<-paste(labs[2:length(labs)-1],"-",labs[2:length(labs)],sep="") 
   rownames(leg)<-zaxis 
    
   assign("leg.col",leg,.GlobalEnv) 
   assign("leg.pch",0,.GlobalEnv) 
    
   if(GUI){ 
   #if(GUI|alt.leg){ 
       showLegend(alt.leg=alt.leg,just.colours = TRUE,GUI=GUI)  
       options(show.error.messages=FALSE) 
   } 
   cat("Colours assigned successfully.\n") 
   invisible(list(prop=what,col=col,leg=leg)) 
} 

# Returns index of valid hexadecimal numbers within a character vector (# and 6-8 characters of 0-9A-F) 
.whichHexaColour<-function(hexe){ 
   which<-sapply(hexe,function(i){ 
       z<-grep("^#[a-f0-9]{6,8}",i,ignore.case=TRUE) 
       return(length(z)>0) 
   },simplify=TRUE) 
   return(which) 
} 

# Sets up the alpha channel (opacity attribute) within the given string of hexadecimal codes of colours [col] 
.transparencyInternational<-function(col,alpha="66"){ 
       if(is.list(col)) col<-unlist(col) 
       out<-sapply(1:length(col),function(i){ 
           nn<-nchar(col[i]) 
           z<-paste(col[i],paste(rep("0",9-nn),collapse=""),sep="") 
           return(z) 
       },simplify=TRUE) 
       substr(out,8,9)<-alpha 
       return(out) 
} 

# Sets opacity (alpha channel) of plotting symbols in GCDkit.  
# Opacity is a hexadecimal number, inverse of transparency 

setTransparency<-function(which.samples=NULL,transp=NULL,alpha=NULL,col.in="black",save=TRUE,GUI=FALSE){ 
   on.exit(options("show.error.messages"=TRUE)) 
   if(save){ 
       col.in<-labels[,"Colour"] 
       names(col.in)<-rownames(labels) 
   } 

   # Translate any colours that are not hexadecimal already 
   if(any(!.whichHexaColour(col.in))){ 
       i<-!.whichHexaColour(col.in) 
       prd<-matrix(nrow=4,ncol=length(col.in),"ff",dimnames=list(c("red","gren","blue","alpha"),names(col.in))) 
       prd[1:3,i]<-as.character(as.hexmode(col2rgb(col.in[i]))) 
       prd[prd=="0"]<-"00" 
       mash<-paste("#",toupper(apply(prd,2,paste,collapse="")),sep="") 
       col.in[i]<-mash[i] # those that were hex already are untouched 
    }    
        
   col.out<-col.in 

   # Select samples for which the transparencies are to be set 
   if(save&is.null(which.samples)){ 
       if(GUI){ 
           which.samples<-selectSamples() 
       }else{ 
           which.samples<-rownames(labels) 
       } 
   } 
    
   if(!is.null(alpha)){ 
       # Test for valid alpha value 
       if(nchar(alpha)!=2){winDialog(type="ok","Invalid input!\nAlpha has to be two characters long.");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
       if(length(grep("[^a-f0-9]",alpha,ignore.case=TRUE))){winDialog(type="ok","Invalid input!\nAlpha has to be hexadecimal number.");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
       transp<-1-as.numeric(as.hexmode(alpha))/255 
   } 

   # Choose the transp value 
   if(is.null(transp)){ 
       #if(!is.na(as.numeric(transp))) 
       transp<-winDialogString("Transparency (0-1)","0") 
       if(length(transp)==0){cat("Cancelled.\n");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
       transp<-as.numeric(transp) 
        
       # Test for valid transparency value 
       if(is.na(transp)){winDialog(type="ok","Invalid input!\nTransparency has to be numeric.");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
       if(transp>1|transp<0){winDialog(type="ok","Out of bounds!\nTransparency has to be 0-1.");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
   } 
    
   if(!is.null(alpha)){ 
       # Test for valid alpha value 
       if(nchar(alpha)!=2){winDialog(type="ok","Invalid input!\nAlpha has to be two characters long.");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
       if(length(grep("[^a-f0-9]",alpha,ignore.case=TRUE))){winDialog(type="ok","Invalid input!\nAlpha has to be hexadecimal number.");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
   }else{ 
       # Convert transparency to alpha value 
       alpha1<-1-transp 
       alpha1<-as.hexmode(floor(alpha1*255)) 
       alpha<-format(alpha1,width=2,upper.case=TRUE) 
   } 
          
    
   if(save){ 
       col.out[which.samples]<-.transparencyInternational(col.in[which.samples],alpha=toupper(alpha)) 
       labels[,"Colour"]<-col.out 
       .assignWithNamespaceHard("labels",labels) 
       message<-"Transparency successfully assigned" 
       if(GUI){ 
           winDialog(type="ok",message) 
           showLegend(new.plot=TRUE) 
       }else{ 
           #cat(message) 
           #cat("\n") 
       } 
   }else{ 
       col.out<-.transparencyInternational(col.in,alpha=toupper(alpha)) 
   } 
   return(col.out) 
} 

.definedPalettes<-function(which,n){ 
   col.list<-c("standard","grays","reds","blues","greens","cyans","violets","yellows","cm.colors","heat.colors","terrain.colors","topo.colors","rainbow","jet.colors")   
   if(is.character(which)) which<-match(which,col.list) 
   if(is.na(which)) return("Invalid palette") 
   if(which>length(col.list)|which<=0) return("Invalid palette") 
    
   # Standard colours (eight of them) 
   std<-(c("black","red","green3","blue","cyan","magenta","yellow","white")) 
   std2<-as.character(as.hexmode(col2rgb(std))) 
   std2<-apply(std2,2,paste,collapse="")   
    
   pal<-switch(which, 
           paste("#",toupper(std2),sep=""), 
           rev(gray(seq(1-1/(n),0,by=-1/(n)))), 
           rgb(r=(2:(n+1))/(n+1),g=0,b=0), 
           rgb(b=(2:(n+1))/(n+1),g=0,r=0), 
           rgb(g=(2:(n+1))/(n+1),r=0,b=0), 
           rgb(g=(2:(n+1))/(n+1),r=0,b=(2:(n+1))/(n+1)), 
           rgb(r=(2:(n+1))/(n+1),g=0,b=(2:(n+1))/(n+1)), 
           rgb(r=(2:(n+1))/(n+1),g=(2:(n+1))/(n+1),b=0), 
           rev(cm.colors(n)), 
           heat.colors(n), 
           terrain.colors(n+1)[1:n], 
           topo.colors(n), 
           rainbow(n, end = 0.9), 
           jet.colors(n) 
       ) 
   pal<-t(as.matrix(pal)) 
   rownames(pal)<-col.list[which] 
   return(pal) 
} 

selectPalette<-function(n,colour.palette=NULL,GUI=TRUE){  
   on.exit(options("show.error.messages"=TRUE))       
   if(n<=0){stop("Invalid number of colours! Quitting...",call. = FALSE)} 
   col.list<-c("grays","reds","blues","greens","cyans","violets","yellows","cm.colors","heat.colors","terrain.colors","topo.colors","rainbow","jet.colors")   
       
   # GUI 
   if(is.null(colour.palette)){        
       # show the table of available palettes 
       if(GUI){     
           n.show<-15 
           if(.Platform$GUI!="AQUA"){ # On Mac this is was ridicously huge, so not active for the moment 
               windows(width = n.show, height = n.show, pointsize = 10,rescale="fit") 
               par(mai=c(0,0,0,0)) 
               ipch <- 0:(n.show-1) 
               by<-n.show 
               ix<-1:n.show 
               plot(1, 1,type='n', xlim=c(-0.5,max(ix)+n.show/10),ylim=c(length(col.list)+0.5,-0.5),axes=FALSE, xlab='',ylab='',asp=1) 
               ee<-lapply(1:(length(col.list)+1),function(j){ 
                   col<-.definedPalettes(j,n.show) 
                   iy<-rep(j,n.show) 
                   points(ix,iy, pch=15, col=col, cex=by)         
               text (n.show, j, rownames(col),col="black",cex=3,adj=1) 
               }) 
           } 
       } 
       colour.palette<-select.list(col.list) 
       if(nchar(colour.palette)==0){cat("Cancelled.\n");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
       if(GUI)ee<-dev.off(dev.cur()) 
    
       } 
        
       colour.palette<-gsub("colours","colors",colour.palette) # Fixes UK spelling to the US one 
       ee<-which(col.list==colour.palette) 
       
       if(length(ee)==1){ # Predefined palette in the system 
            pal<-.definedPalettes(ee+1,n) 
       }else{ # User defined palette function? 
           pal<-try(eval(parse(text=paste(colour.palette,"(",n,")",sep="")))) 
           if(class(pal)=="try-error"){ 
               stop("Invalid colour.palette scheme! Quitting...",call. = FALSE) 
           } 
            
           pal2<-substr(pal,2,length(pal)) 
           pal2<-try(strtoi(pal2,16L)) 
           if(class(pal2)=="try-error"){ 
               stop("Invalid colour.palette scheme! Quitting...",call. = FALSE) 
           } 
           pal<-t(as.matrix(pal)) 
           rownames(pal)<-colour.palette   
       }     
      return(pal) 
} 

# if in plate, erase the given slot 
.eraseScreen<-function(){ 
       old<-par(usr = c(0, 1, 0, 1), mar = c(0,0, 0, 0), oma=c(0,0,4,0)) 
       par(new = TRUE) 
       plot.new() 
       #box(which="figure",col="pink",lwd=4) 
       #rect(0,0,1,1,lty="blank",col="red") 
       polygon(c(0, 1, 1, 0), c(0, 0, 1, 1), border = NA, col = "white") 
       par(old) 
} 

# Plots mineral proportions from matrix x, minerals in cols, temperature in C in rows 
.phasePropPlotRedraw<-function(col="gray",leg.pos="bottomleft",leg.bg="#FFFFFFAA",xlab=NULL,ylab="Phase proportions",xlim=NULL,ylim=NULL,border="white",main=""){ 
   on.exit(options("show.error.messages"=TRUE)) 
    
   options("show.error.messages"=FALSE) 
   sheet<-get("sheet",.GlobalEnv) 
    
   if(is.null(xlim)) xlim<-sheet$demo$call$xlim 
   if(is.null(ylim)) ylim<-sheet$demo$call$ylim 
    
   my.args<-sheet$demo$temp$phasePlt1 

   # Plot it
   ee<-barplot(height=y.data,names.arg=NULL,space=my.args$space,col=sheet$demo$call$col, 
       border=my.args$border,xlim=xlim,ylim=ylim,xlab=sheet$demo$call$xlab,ylab=sheet$demo$call$ylab, 
       main=sheet$demo$call$main,plot=TRUE,axes=TRUE,add=FALSE,main.cex=1,
       # Legend from here on
       legend.text=rownames(y.data),args.legend=list(x=my.args$leg.pos,
       fill=rev(sheet$demo$call$col),border="black",bg=my.args$leg.bg)) 
   
   # Add grid lines etc 
   rug(ee,ticksize=-0.03,side=1,col="black") 
   #abline(h=pretty(ylim),col="gray") 
    
   # Nefunguje napr. pro asimilaci, teploty nejsou ekvidistantni 
   #x.pret<-pretty(as.numeric(colnames(y.data))) 
   #x<-as.numeric(colnames(y.data)) 
   #x.orig<-ee[1]+2*(ee[length(ee)]-ee[1])/(length(ee)-1) 
   #a<-(ee[length(ee)]-ee[1])/(x[length(x)]-x[1]) 
   #a<-(ee[2]-ee[1])/(x[2]-x[1]) 
   #b<-ee[1]-a*x[1] 
   #lab.orig<-a*x.pret+b 
   #axis(3,at=lab.orig,lab=x.pret) 
   #axis(1) 
   #axis(2) 
   box() 
    
   # Legend 
   #legend(x=my.args$leg.pos,legend=rev(rownames(y.data)),col=rev(sheet$demo$call$col),pch=15,bg=my.args$leg.bg) 
   invisible() 
} 

phasePropPlot<-function(mat,renormalize=TRUE,col=NULL,palette="jet.colors",leg.pos="bottomleft",leg.bg="#FFFFFFAA",xlab=expression(Temperature~degree*C),ylab="Phase proportions",xlim=NULL,ylim=c(0,1),border="white",main=""){ 
   if(is.null(col)) col<-c("lightgray",selectPalette(ncol(mat)-1,palette,GUI=FALSE)) 
   col<-rep(col,times=100)[1:ncol(mat)] 
    
   # Recast all components to a sum of 1 
   if(renormalize){ 
       mat.new<-t(normalize2total(mat,1)) 
       ylim<-c(0,1) 
   }else{ 
       sums<-apply(round(mat,2),1,sum,na.rm=TRUE) 
       ylim<-c(0,max(sums)) 
       mat.new<-t(mat) 
   } 
   mat.new[is.na(mat.new)]<-0 
    
   x.tck<-barplot(height=mat.new,col=col,ylim=ylim,border=border,main=main,plot=FALSE) 
    
   # Get the Figaro template ready 
   temp<-list(GCDkit=list(plot.type="phasePlot")) 
   temp<-c(temp,list( 
           phasePlt1=list("phasePlot",col=col,leg.pos=leg.pos,leg.bg=leg.bg,border=border,xlim=xlim,ylim=ylim,main=main) 
       ) 
   ) 
   
   #colnames(mat.new)<-NULL 
   assign("x.data",x.tck,.GlobalEnv) 
   assign("y.data",mat.new,.GlobalEnv) 
    
   # Call Figaro 
   sheet<-list(demo=list(fun="plot",call=list(x=1,y=1,col=col,xaxs="i",yaxs="i",xlab=xlab,ylab=ylab,xlim=xlim,ylim=ylim,log="",main=main),template=temp)) 
    
   assign("sheet",sheet,.GlobalEnv) 
   pp<-figaro(demo,prefix="sheet") 
   assign("pp",pp,.GlobalEnv) 
    
   # Draw it 
   figRedraw() 
   figaroOff() 
   invisible(mat.new) 
} 

##################################################################### 
#                                                                   # 
#                     scatterplotsmooth                             # 
#                         for GCDkit                                # 
#                                                                   # 
##################################################################### 

# Original scattersmooth function only slightly modified from: 
# Eilers PHC, Goeman JJ (2004) Enhancing scatterplots with smoothed densities.  
# Bioinformatics 20:623-628 

#' Smooth a scatterplot 
#' 
#' This function takes two vectors of equal length and produces a smooth 
#' representation of their scatterplot. This is useful for large datasets, 
#' where many dots overlap each other and suggest a too wide point cloud. 
#' function also reduce the time for plotting and printing scatterplots 
#' with very many observations. 
#' 
#' @param x, y vectors of equal length, giving the coordinates of the data points 
#' @param nbin an integer, giving the number of bins for x and y, or a vector with two integers 
#' @param lambda the smoothing parameter; larger lambda gives 
#' @param ndots size of the sample of individual dots to show 
#' @param csize size of the dots 
#' @param ticks show axes ticks if TRUE 
#' @param pow compute a power of the counts in the bins before smoothing 
#' @param rcond make the smooth plot row conditional 
#' @param ccond make the smooth plot column conditional 
#' @param xlim set the boundaries of x; data point outside this range are discarded 
#' @param ylim set the boundaries of y; data point outside this range are discarded 
#' @param show if TRUE: show the smoothed histogram; if FALSE, only compute it 


.scattersmoothMain = function(x, y, xlab="", ylab="", nbin = 100, lambda = 1, 
                        ndots = 500, csize = 0.3, ticks = TRUE, pow = 1, rcond = FALSE, ccond = FALSE, 
                        xlim = range(x), ylim = range(y),  
                        col="blue", pch = 15, pal=heat.colors(100), show = TRUE) { 

 # Check input 
 sel = which(!(is.na(x) | is.na(y))) 
 x = x[sel] 
 y = y[sel] 
 if (length(x) != length(y)) 
   stop("lengths of x and y do not match") 
 if ( (length(x) < 2) | (length(y) < 2) ) 
   stop("x and y should be vectors") 
 if ( !is.numeric(x) | !is.numeric(y) ) 
   stop("x and y should contain numeric values") 
 if ( all(!is.numeric(lambda)) | all(lambda < 0) | (length(lambda) > 2) ) 
   stop("lambda should be numeric and positive") 
 if ( length(lambda) == 1 ) 
   lambda = c(lambda, lambda) 
 if (all(!is.numeric(nbin)) | all(nbin < 1) | (length(nbin) > 2) ) 
   stop("nbin should be a strictly positive integer") 
 if ( length(nbin) == 1 ) 
   nbin = c(nbin, nbin) 
 if (!is.numeric(ndots) | (ndots < 0) | (length(ndots) > 1) ) 
   stop("ndots should be a non-negative integer") 
 ndot = floor(ndots) 
 m = length(x) 

 # Put the x-values into bins 
 xmin = xlim[1] 
 xmax = xlim[2] 
 dx = (xmax - xmin) / (nbin[1] - 1) 
 xbin = floor(1 + (x - xmin) / dx) 
 xgrid = xmin + (1:nbin[1] - 0.5) * dx 

 # Put the y-values into bins 
 ymin = ylim[1] 
 ymax = ylim[2] 
 dy = (ymax - ymin) / (nbin[2]-1) 
 ybin = floor(1 + (y - ymin) / dy) 
 ygrid = ymin + (1:nbin[2] - 0.5) * dy 

 # Select points within boundaries 
 sel = 1 <= xbin & xbin <= nbin[1] & 1 <= ybin & ybin <= nbin[2] 
 xbin = xbin[sel] 
 ybin = ybin[sel] 
 nmiss = length(x) - sum(sel) 

 # Create the unsmoothed histogram 
 Hraw = .fillhist(xbin, ybin, nbin) 

 # Conditional on columns (ccond == T) 
 wr = rep(1, nrow(Hraw)) 
 wc = rep(1, ncol(Hraw)) 
 if (ccond) { 
   wc = apply(Hraw, 2, sum) 
   wc = wc / mean(wc) 
 } 

 # Conditional on rows (rcond == T) 
 if (rcond) { 
   wr = apply(Hraw, 1, sum) 
   wr = wr / mean(wr) 
 } 

 # Do the smoothing 
 Hsmooth = .smooth2d(Hraw, lambda, wr, wc) 

 # Do the plotting 
 if (ticks == F) par(xaxt = 'n', yaxt = 'n') 
 if (show) { 
   # Plot coloured image 
   image(x = xgrid, y = ygrid, z = -Hsmooth ^ pow, xlab = annotate(xlab), ylab = annotate(ylab), col = pal) 

   # Plot selection of dots 
   if (ndots > 0) { 
     ndots = min(m, ndot) 
     sel = sort.list(rnorm(m))[1:ndots] 
     points(x[sel], y[sel], cex = csize, col = col, pch = pch) 
   } 
   box() 
 } 

 # Return results 
 sg = list(Hraw = Hraw, Hsmooth = Hsmooth, xgrid = xgrid, ygrid = ygrid, 
           nmiss = nmiss, seldots = sel) 
 return(sg) 
} 


#' Two-dimensional exponential smoother 
#' 
#' @param H  matrix, containing the values to be smoothed 
#' @param lambda  number or 2-vector, to set the amount of smoothing for x and y (large lambda gives strong smoothing). 
#' @param wr  vector, contains weights for the rows 
#' @param wc  vector, contains weights for the columns 
#' 
#' @return A matrix with same size as \code{H} with smoothed values 
#' 
#' @examples 
#' n = 100 
#' x = seq(0, 2 * pi, length = n) 
#' Y = outer(sin(x), cos(x)) 
#' Y = Y + matrix(rnorm(n ^ 2), n, n) 
#' Z = .smooth2d(Y) 
#' par(mfrow = c(1, 2)) 
#' image(Y) 
#' image(Z) 
#' 
#' @export 


.smooth2d = function (H, lambda = 1, wr = NULL, wc = NULL) { 
 # 2-D exponential smoother 

 if (length(lambda) == 1) lambda = c(lambda, lambda) 

 # Build penalty matrices 
 m = nrow(H) 
 n = ncol(H) 
 if (is.null(wr)) wr = rep(1, m) 
 E1 = diag(wr) 
 if (is.null(wc)) wc = rep(1, n) 
 E2 = diag(wc) 
 D1x = diff(diag(m)) 
 D1y = diff(diag(n)) 
 D2x = diff(D1x) 
 D2y = diff(D1y) 
 Qx = E1 + lambda[1]^2 * t(D2x) %*% D2x + 2 * lambda[1] * t(D1x) %*% D1x 
 Qy = E2 + lambda[2]^2 * t(D2y) %*% D2y + 2 * lambda[2] * t(D1y) %*% D1y 

 # Smooth 
 H = t(solve(Qy, t(solve(Qx, H)))) 
 return(H) 
} 

#' Fill a two-dimensional histogram 
#' 
#' @param xb  vector with row indices contaning integers in the range from 1 to nb. 
#' @param yb  vector with column indices containing integers in the range from 1 to nb 
#' @param nb  vector with two numbers, the numbers of bins for rows and columns. 
#' 
#' @export 

.fillhist = function(xb, yb, nb)  { 
 H = matrix(rep(0, prod(nb)), nb[1], nb[2]) 
 for (i in 1:length(xb)) H[xb[i], yb[i]] = H[xb[i], yb[i]] + 1 
 return(H) 
} 

##################################################################### 
#                                                                   # 
#                     Interface to GCDkit                           # 
#                            by VJ                                  # 
#                                                                   # 
##################################################################### 
scattersmooth<-function(xlab = NULL, ylab = NULL, samples = NULL, nbin = 100, lambda = 1, pal = heat.colors(100), 
   pch = 15, col = "blue", cex = 0.3, xlim = NULL, ylim = NULL, ...){ 
  if(is.null(xlab)){      
       xlab<-selectColumnLabel(colnames(WR),message="x-axis, e.g. (SiO2+2.1)*TiO2/3\nor press ENTER to pick from a list",empty.ok=FALSE,silent=TRUE)     
       if(is.null(xlab)){cat("Cancelled.\n");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
       if(!is.na(as.numeric(xlab)))xlab<-colnames(WR)[as.numeric(xlab)] 
       GUI<-TRUE 
   }else{ 
       GUI<-FALSE 
   } 
    
   # xy coordinates 
   if(any(colnames(WR)==xlab)){ 
       x<-WR[,xlab] 
   }else{ 
       ee<-calcCore(xlab) 
       x<-ee$results 
       xlab<-ee$equation 
   } 
    
   if(is.null(ylab)){      
       ylab<-selectColumnLabel(colnames(WR),message="y-axis, e.g. (SiO2+2.1)*TiO2/3\nor press ENTER to pick from a list",empty.ok=FALSE,silent=TRUE)     
       if(is.null(ylab)){cat("Cancelled.\n");options("show.error.messages"=FALSE);stop(call. = TRUE)} 
       if(!is.na(as.numeric(ylab)))ylab<-colnames(WR)[as.numeric(ylab)] 
   } 
    
   if(any(colnames(WR)==ylab)){ 
       y<-WR[,ylab] 
   }else{ 
       ee<-calcCore(ylab) 
       y<-ee$results 
       ylab<-ee$equation 
   } 

   # select subset for plotting 
   if(is.null(samples)){ 
       if(GUI){ 
           samples<-selectSamples(print=FALSE) 
           #if(!getOption("gcd.shut.up")) print(samples) 
       }else{ 
           samples<-names(x) 
       } 
   } 
   x<-x[samples] 
   y<-y[samples] 
    
   # Only complete pairs can be plotted 
   x<-x[!is.na(x)&!is.na(y)] 
   y<-y[!is.na(x)&!is.na(y)] 
    
   # axes ranges 
   if(is.null(xlim)){ 
       xlim<-range(x)#,na.rm=TRUE) 
   } 
    
   if(is.null(ylim)){ 
       ylim<-range(y)#,na.rm=TRUE) 
   } 
    
   # colour palette 
   if(is.null(pal)){ 
       pal<-selectPalette(100) 
   } 
   sq<-.scattersmoothMain(x=x,y=y,xlab=xlab,ylab=ylab,nbin=nbin,lambda=lambda,pal=pal,pch=pch,col=col,csize=cex,xlim=xlim,ylim=ylim,...) 
   figaroOff() 
   invisible(sq) 
} 
