
#####################################################################
#             CIPW norm  with hornblende and biotite                #
#                       (Hutchison, 1975)                           #
#####################################################################
# normsum - recast the norm to 100 %?
# cancrinite - is cancrinite present?
# spinel - shall be spinel calculated for rocks with SiO2<45 %?
CIPWhb<-function(wrdata,precision=getOption("gcd.digits"),normsum=FALSE,cancrinite=FALSE,spinel=FALSE,complete.results=FALSE){
    
    CIPWhb.main<-function(wrdata,digits=getOption("gcd.digits"),normsum=FALSE,cancrinite=FALSE,spinel=FALSE){ 
    result.names<-c("Q","C","Or","Ab","An","Lc","Ne","Kp","Nc","Ac","Ns","Ks","Di","MgDi","FeDi","Wo","Hy","En","Fs","Ol","Fo","Fa","Dcs","Mt","Il","Hm","Tn","Pf","Ru","Ap","Fr","Py","Cc","Sp","MgSp","FeSp","Bi","MgBi","FeBi","Hbl","Act","MgAct","FeAct","Ed","MgEd","FeEd","Ri","Sum") 
    on.exit(options("show.error.messages"=TRUE))

        ######################################################################
        #                              Main function                         #
        ######################################################################
        CIPWnorm2<-function(x){
            names(x)<-c("si","ti","al","fe3","fe2","mn","mg","ca","na","k","H2O","co2","p","fl","s")
            x<-as.list(x)
            attach(x,warn.conflicts=FALSE)

            fe2<-fe2 + mn

            norm.names<-c("qtz","cor","ort","ab","an","lc","ne","kp","nc","ac","ns","ks","di","mgdi","fedi","wo","hy","en","fs","ol","fo","fa","cs","mt","il","hm","tn","pf","ru","ap","fr","pr","cc","sp","mgsp","fesp","bi","mgbi","febi","ho","act","mgact","feact","ed","mged","feed","ri","mgr","fer","femg")
            y<-rep(0,length(norm.names))
            names(y)<-norm.names
            y<-as.list(y)
            #attach(y,warn.conflicts=FALSE)

            if (ca >= 10 / 3 * p){
                y$ap<-p
                ca<-ca - y$ap * 10 / 3
            }else{
                y$ap<-3/10 * ca
                p<-p - y$ap
                ca<-0
            }

            if (fl >= 2 / 3 * y$ap & !is.na(fl)){
                fl<-fl - 2 / 3 * y$ap
            }else{
                fl<-0
            }

            if (ca >= .5 * fl){
                y$fr<-.5 * fl
                ca<-ca - y$fr
            }else{
                y$fr<-ca
                fl<-fl - 2 * y$fr
                ca<-0
            }

            if(!is.na(s)){
                if (fe2 >= .5 * s){
                    y$pr<-.5 * s
                    fe2<-fe2 - y$pr
                }else{
                    y$pr<-fe2
                    s<-s - 2 * y$pr
                    fe2<-0
                }
            }
            
            if (cancrinite){y$nc<-co2; na<-na - y$nc}
            
            if(!is.na(co2)){
                if (ca >= co2){
                    y$cc<-co2
                    ca<-ca - y$cc
                    co2<-0
                }else{
                    y$cc<-ca
                    co2<-co2 - y$cc
                    ca<-0
                }
            }

            if (fe2 >= ti){  
                y$il<-ti
                fe2<-fe2 - y$il
                ti<-0
            }else{
                y$il<-fe2
                ti<-ti - y$il
                fe2<-0
            }

            if (al >= k){  
                y$ort<-k
                al<-al - y$ort
                si<-si - 6 * y$ort
                k<-0
            }else{
                y$ort<-al
                k<-k - y$ort
                si<-si - 6 * y$ort
                al<-0
                y$ks<-k
                si<-si - y$ks
                k<-0
            }


            if (al >= na){  
                y$ab<-na
                al<-al - y$ab
                si<-si - 6 * y$ab
                na<-0
            }else{
                y$ab<-al
                na<-na - y$ab
                si<-si - 6 * y$ab
                al<-0
            }
   
            if (fe3 <= fe2 / 3){
                if (na <= fe3){
                    y$ri <- na
                    fe3 <- fe3 - ri
                    fe2 <- fe2 - 3 * y$ri
                    si <- si - 8 * y$ri
                    na <- 0
                }else{
                    y$ri <- fe3
                    na <- na - y$ri
                    fe2 <- fe2 - 3 * y$ri
                    si <- si - 8 * y$ri
                    fe3 <- 0
                }
            }else{
                if (na <= fe2 / 3){
                    y$ri <- na
                    fe3 <- fe3 - y$ri
                    fe2 <- fe2 - 3 * y$ri
                    si <- si - 8 * y$ri
                    na <- 0
                }else{
                    y$ri <- fe2 / 3
                    na <- na - y$ri
                    fe3 <- fe3 - y$ri
                    si <- si - 8 * y$ri
                    fe2 <- 0
                }
            }

            y$ns <- na
            si <- si - y$ns

            if (fe3 >= fe2){
                y$mt<-fe2
                fe3<-fe3 - y$mt
                fe2<-0
                y$hm<-fe3
                fe3<-0
            }else{
                y$mt<-fe3
                fe2<-fe2 - y$mt
                fe3<-0
            }

            y$fer<-fe2 / (fe2 + mg)
            y$mgr<-mg / (fe2 + mg)
            y$femg<-fe2 + mg

            if (spinel& si< 45){  
                if (y$femg <= y$cor){  
                    y$mgsp<-y$mgr * y$femg
                    y$fesp<-y$fer * y$femg
                    y$cor<-y$cor - y$mgsp - y$fesp

                    y$mgsp<-y$mgr * y$cor
                    y$fesp<-y$fer * y$cor
                    y$cor<-0
                    y$femg<-y$femg - y$mgsp - y$fesp
                }
            }

            if (al >= ca){  
                y$an<-ca
                al<-al - y$an
                ca<-0
                si<-si - 2 * y$an
                y$cor<-al
                al<-0
            }else{
                y$an<-al
                ca<-ca - y$an
                si<-si - 2 * y$an
                al<-0
            }

            if (y$femg <= 6 * y$ort){
                y$mgbi <- 1 / 6 * y$mgr * y$femg
                y$febi <- 1 / 6 * y$fer * y$femg
                y$ort <- y$ort - y$mgbi - y$febi
                y$femg <- 0
            }else{
                y$mgbi <- y$mgr * y$ort
                y$febi <- y$fer * y$ort
                y$femg <- y$femg - 6 * (y$febi + y$mgbi)
                y$ort <- 0
            }

            if (y$femg <= 5 / 2 * ca){
                y$mgact <- 1 / 5 * y$mgr * y$femg
                y$feact <- 1 / 5 * y$fer * y$femg
                ca <- ca - 2 * (y$mgact + y$feact)
                y$femg <- 0
                y$wo <- ca
                si <- si - 8 * (y$feact + y$mgact) - y$wo
                ca <- 0
            }else{
                y$mgact <- .5 * y$mgr * ca
                y$feact <- .5 * y$fer * ca
                y$femg <- y$femg - 5 * (y$feact + y$mgact)
                ca <- 0
                y$en <- y$mgr * y$femg
                y$fs <- y$fer * y$femg
                si <- si - 8 * (y$mgact + y$feact) - y$en - y$fs
            }

            if (si >= 0){
                y$qtz<-si
                w<-.Ende(y)
                return(w)
            }else{
                y$qtz<-0
                d<-abs(si)
            }

            if (y$mgact + y$feact >= 2 * y$ab){
                if (ab >= d / 8){
                    y$mged <- y$mgr * d / 8
                    y$feed <- y$fer * d / 8
                    y$mgact <- y$mgact - 2 * y$mged
                    y$feact <- y$feact - 2 * y$feed
                    y$ab <- y$ab - (y$mged + y$feed)
                    w<-.Ende(y)
                    return(w)
                }else{
                    y$mged <- y$mgr * y$ab
                    y$feed <- y$fer * y$ab
                    y$mgact <- y$mgact - 2 * y$mged
                    y$feact <- y$feact - 2 * y$feed
                    d <- d - 8 * (y$mged + y$feed)
                    y$ab <- 0
                }
            }else{
                if(y$mgact + y$feact >= d / 4){
                    y$mged <- y$mgr * d / 8
                    y$feed <- y$fer * d / 8
                    y$mgact <- y$mgact - 2 * y$mged
                    y$feact <- y$feact - 2 * y$feed
                    y$ab <- y$ab - (y$mged + y$feed)
                    w<-.Ende(y)
                    return(w)        
                }else{
                    y$mged <- .5 * y$mgact
                    y$feed <- .5 * y$feact
                    y$ab <- y$ab - (y$mged + y$feed)
                    d <- d - 8 * (y$mged + y$feed)
                    y$mgact <- 0
                    y$feact <- 0
                }
            }

            if (d <= .5 * (y$en + y$fs)){
                y$fo <- y$mgr * d
                y$fa <- y$fer * d
                y$en <- y$en - 2 * y$fo
                y$fs <- y$fs - 2 * y$fa
                w<-.Ende(y)
                return(w)
            }else{
                y$fo <- .5 * y$en
                y$fa <- .5 * y$fs
                d <- d - .5 * (y$en + y$fs)
                y$en <- 0
                y$fs <- 0
            }

            if (y$fo + y$fa <= .5 * y$cor){
                if((y$fo + y$fa) >= d){
                    y$mgsp <- y$mgsp + 2 * y$mgr * d
                    y$fesp <- y$fesp + 2 * y$fer * d
                    y$cor <- y$cor - 2 * d
                    y$fo <- y$fo - y$mgr * d
                    y$fa <- y$fa - y$fer * d
                    w<-.Ende(y)
                    return(w)            
                }else{
                    y$mgsp <- y$mgsp + 2 * y$fo
                    y$fesp <- y$fesp + 2 * y$fa
                    y$cor <- y$cor - 2 * (y$fo + y$fa)
                    d <- d - (y$fo + y$fa)
                    y$fo <- 0
                    y$fa <- 0
                }
            }else{
                if (y$cor >= 2 * d){
                    y$mgsp <- y$mgsp + 2 * y$mgr * d
                    y$fesp <- y$fesp + 2 * y$fer * d
                    y$cor <- y$cor - 2 * d
                    y$fo <- y$fo - y$mgr * d
                    y$fa <- y$fa - y$fer * d
                    w<-.Ende(y)
                    return(w)
                }else{
                    y$mgsp <- y$mgsp + 2 * y$mgr * y$cor
                    y$fesp <- y$fesp + 2 * y$fer * y$cor
                    d <- d - .5 * y$cor
                    y$fo <- y$fo - .5 * y$mgr * y$cor
                    y$fa <- y$fa - .5 * y$fer * y$cor
                    y$cor <- 0
                }
            }

            if (d <= 4 * y$ab){
                y$ne <- d / 4
                y$ab <- y$ab - d / 4
                w<-.Ende(y)
                return(w)
            }else{
                y$ne <- y$ab
                d <- d - 4 * y$ab
                y$ab <- 0
            }
            w<-.Ende(y)
            return(w)
        }

        .Ende<-function(y){
            y$en<-y$mgr * y$hy
            y$fs<-y$fer * y$hy
            y$fo<-y$mgr * y$ol
            y$fa<-y$fer * y$ol
            y$mgdi<-y$mgr * y$di
            y$fedi<-y$fer * y$di

            w<-unlist(y)
            w<-w[1:47]

            # Molecular weights of the calculated normative minerals [Hutchison, 1974, 1975)
            CIPWweight<-c(60.08,101.96,556.64,524.42,278.20,436.48,284.10,316.32,105.99,461.99,122.06,154.28,1,216.55,248.09,116.16,1,100.39,131.93,1,140.70,203.78,172.24,231.54,151.75,159.69,196.06,135.98,79.90,336.21,78.08,119.98,100.09,1,142.27,173.81,1,798.5,987.74,1,1,794.35,952.05,1,1632.48,1947.88,917.87)

            w<-w*CIPWweight

            w[13]<-w[14]+w[15]
            w[17]<-w[18]+w[19]
            w[20]<-w[21]+w[22]
            w[34]<-w[35]+w[36]
            w[37]<-w[38]+w[39]
            w[41]<-w[42]+w[43]
            w[44]<-w[45]+w[46] 
            w[40]<-w[41]+w[44]+w[47]

            suma<-sum(w[-c(13,17,20,34,37,40,41,44)])
          
            # Recast to 100% anhydrous?
            if (normsum){
                w<-w*100/suma
                w[48]<-sum(w[-c(13,17,20,34,37,40,41,44)])
            }else{
                w[48]<-suma
            }
            return(w)
        }


    ######################################################################
    #                              Entry point                           #
    ######################################################################

    oxides<-c("SiO2","TiO2","Al2O3","Fe2O3","FeO","MnO","MgO","CaO","Na2O","K2O","H2O.PLUS","CO2","P2O5","F","S")   

    # Add missing columns for majors
    ################################
    wrdata<-sapply(oxides,function(f){
        if(!any(colnames(wrdata)==f)){
            return(rep(NA,nrow(wrdata)))
        }else{
            return(wrdata[,f])
        }
    },simplify=TRUE)

    try.it<-function(x){
        CIPWnorm2(x)
    }

    if(getOption("gcd.menus")!=""){
        pb<-winProgressBar(title = "CIPW with hornblende and biotite", label = "Processing sample",min = 1, max = nrow(wrdata), initial = 1, width = 300)
    }else{
        if(!getOption("gcd.shut.up"))pb<-txtProgressBar(title = "CIPW with hornblende and biotite", label = "Processing sample",min = 1, max = nrow(wrdata), initial = 1,char = "=",width = NA, style = 3)
    }

    results<-sapply(1:nrow(wrdata),function(fff){
        if(getOption("gcd.menus")!=""){
            setWinProgressBar(pb, fff, title = NULL, label = paste("Sample",fff,"of",nrow(wrdata)))
        }else{
            if(!getOption("gcd.shut.up"))setTxtProgressBar(pb, fff, title = NULL, label = paste("Sample",fff,"of",nrow(wrdata)))
        }
        dataset<-wrdata[fff,oxides]/MW[oxides]
        dataset[is.na(dataset)]<-0
        options(show.error.messages = FALSE)
        res<-try(try.it(dataset))
        options(show.error.messages = TRUE)
    
            if((class(res))!="numeric"){
                #cat("Sample",rownames(wrdata)[fff],"- ")
                err<-res[1]
                #cat("Error in calculation\n")
                #cat(err)
                w<-rep(NA,length(result.names))
            }else{
                w<-res
            }
            detach(x)
            return(w)
        },simplify=TRUE)
        
        results<-matrix(unlist(results),ncol=length(result.names),byrow=TRUE)
        colnames(results)<-result.names
        rownames(results)<-rownames(wrdata)
        
        #if(.Platform$GUI!="RTerm"|!getOption("gcd.shut.up"))close(pb)
        if(.Platform$GUI=="Rgui"|.Platform$GUI=="AQUA"){
            close(pb)
        }else{
            if(!getOption("gcd.shut.up"))close(pb)
        }   
        return(results)
    }

    results<-CIPWhb.main(wrdata,normsum=FALSE)
    if(!complete.results){
        results<-results[,is.na(match(colnames(results),c("En","Fs","Fo","Fa","MgDi","FeDi","MgBi","FeBi","Act","FeAct","MgAct","Ed","FeEd","MgEd")))]
        ee<-apply(results==0,2,sum,na.rm=TRUE)
        results<-results[,ee!=nrow(results)]
        results<-results[!is.na(results[,"Sum"]),]
    }

    if(!getOption("gcd.shut.up"))print(t(round(results,precision)))

    if(nrow(results)<nrow(wrdata)){
        if(!getOption("gcd.shut.up")){
            cat("\nNot calculated: \n")
            print(rownames(wrdata)[is.na(match(rownames(wrdata),rownames(results)))])            
        }
    }
    assign("results",results,.GlobalEnv)
    invisible(results)
}                 
