\encoding{Windows-1250}
\name{Saccani}
\alias{Saccani}

\title{Nb[N]-Th[N] basalt discrimination diagram (Saccani 2015)}

\description{
Assigns data for Saccani's diagram into Figaro template (list '\code{sheet}') and                                   
appropriate values into '\code{x.data}' and '\code{y.data}', the latter also into 
the matrix '\code{results}'.
}

\usage{
Saccani(plot.txt = getOption("gcd.plot.text"))
}

\details{
The diagram of \emph{Saccani (2015)}, based on NMORB-normalized Nb[N]-Th[N] values \emph{(Sun and McDonough 1989)}, 
serves for discrimination of geotectonic setting of basalts. The inidividual fields are illustrated on the 
original figures of Saccani's work:

\if{html}{\figure{saccani.png}}
\if{latex}{\figure{saccani.png}{options: width=4.5in}}

\if{html}{\figure{saccani2.png}}
\if{latex}{\figure{saccani2.png}{options: width=2.5in}}
}

\value{
  \item{sheet}{list with Figaro Style Sheet data}
  \item{x.data, y.data}{Nb and Th concentrations normalized to NMORB}
}

\references{
Saccani E (2015) A new method of discriminating different types of post-Archean 
ophiolitic basalts and their tectonic significance using Th-Nb and Ce-Dy-Yb 
systematics. Geosci Front 6: 481-501
\doi{10.1016/j.gsf.2014.03.006}

Sun SS, McDonough WF (1989) Chemical and isotopic systematics of oceanic 
basalts: implications for mantle composition and processes. In: Saunders A D, 
Norry M (eds) Magmatism in Ocean Basins. Geological Society of London Special 
Publications 42, pp 313-345
\doi{10.1144/GSL.SP.1989.042.01.19}
}

\author{Vojtch Janouek, \email{vojtech.janousek@geology.cz}}

\seealso{
\link{figaro}
\link{plotDiagram}
}

\examples{
# plots the Th[N]-Nb[N] binary diagram for the current dataset
plotDiagram("Saccani", FALSE)
}

\keyword{hplot}
\concept{Geotectonic}
\concept{Plot}
\concept{Menu: Geotectonic}
