\encoding{Windows-1250}
\name{fousy}
\alias{fousy}  
\title{Plotting error bars}

\description{
Using the function \code{fousy} can be added error bars for the x, and or, y
coordinate(s) of a binary plot.
}

\usage{
fousy(x,y,sy,sx=0,fousek=0.05,col="black",lwd=1,figaro=TRUE)
}

\arguments{
  \item{x, y}{data points coordinates}
  \item{sx, sy}{one sigma errors}
  \item{fousek}{(optional) length of the error bars as a fraction of the FOV}
  \item{col}{colour}
  \item{lwd}{line width}
  \item{figaro}{logical; should the error bars also added to the Figaro template?}
}

\details{
This function plots error bars plus/minus 1 sigma. Optionally, these error bars are also added to the 
Figaro template of the current plot. In this case, the coordinates would be typically \code{x.data}
and \code{y.data}.
 
}

\examples{
    data(sazava)
    accessVar("sazava")

    binary("SiO2","Ba",xmin=45,xmax=70,ymin=0)
    fousy(WR[,"SiO2"],WR[,"Ba"],sx=1,sy=25)

    plotDiagram("PeceTaylor",FALSE,TRUE)
    fousy(x.data,y.data,sy=0.3,fousek=FALSE)
    
    fousy(x.data,y.data,sy=0.3,fousek=0.05)
    
    fousy(x.data,y.data,sy=0.3,fousek=0.1)

    plotDiagram("DebonPQ",FALSE,TRUE)
    fousy(x.data,y.data,sx=10,sy=10,col="darkgreen",lwd=2)
}

\keyword{internal}
\keyword{aplot}
\concept{Plot}

\author{
Vojtch Janouek, \email{vojtech.janousek@geology.cz}
}
