\encoding{Windows-1250}
\name{accessVar}
\title{Accessing data in memory of R}
\alias{accessVar}


\description{
    Loads data already present in memory of R into GCDkit.
}

\usage{
accessVar(var = NULL, source.first = TRUE, source.diagrams = TRUE, source.plugins = TRUE,
    poke.data = TRUE, GUI = FALSE)
}

\arguments{
    \item{var}{numeric matrix, or a text string specifying a name of such a variable to be accessed}
    \item{source.first}{logical; should be the GCDkit.r sourced?}
    \item{source.diagrams}{logical; should be built the lists of available diagrams?}
    \item{source.plugins}{logical; should be  all the plugins sourced?}
    \item{poke.data}{logical; should the dataset be stored in the WRCube?}
    \item{GUI}{logical; is the function called from GUI (or from the command line)?}
}

\details{
    This function enables accessing a variable already present in R. 
    The variable is a numeric matrix or dataframe that can be either passed
    directly, or referred to by its name.   
    Typically is the function \code{accessVar} used to access sample data sets, 
    previously made available using the command \code{data}. See Examples.
    
    If \code{source.diagrams = TRUE}, then two lists of applicable diagrams
    are built (based on data present in the current dataset), 
    \code{claslist} and \code{tectlist}. 
}

\value{
    \item{WR}{numeric matrix: all numeric data}
    \item{labels}{data frame:  all at least partly character fields;
    \code{labels$Symbol} contains plotting symbols and
    \code{labels$Colour} the plotting colours}

    The function prints a short summary about the attached data.
    It also loads and executes the Plugins, i.e. all the R code that
    is currently stored in the subdirectory '\code{\\Plugin}'.
}

\examples{
    data(swiss)
    accessVar(swiss)
    binary("Catholic","Education")

    data(sazava)
    accessVar("sazava")
    binary("SiO2","Ba")
}

\keyword{manip}
\concept{Menu: GCDkit}
\author{Vojtch Janouek, \email{vojtech.janousek@geology.cz}}
