\encoding{Windows-1250}
\name{blatna}
\docType{data}
\alias{blatna}
\alias{blatna_iso}
\title{Whole-rock geochemical composition of the Blatn suite, Central Bohemian Plutonic Complex}

\description{
    These data sets give the whole-rock major- and trace-element contents as well as 
    Sr-Nd isotopic composition in selected samples (monzogabbros, hybrid quartz monzonites 
    and granodiorites) of the  c. 345 Ma old high-K calc-alkaline Blatn suite of the 
    Variscan Central Bohemian Plutonic Complex 
    (Bohemian Massif, Czech Republic). 
}
\usage{
data(blatna)
data(blatna_iso)
}

\format{
    A data frame containing 11 (\code{blatna}) and 9 (\code{blatna_iso}) 
    observations, respectively.
}

\examples{
    data(blatna)
    accessVar("blatna")
    binary("SiO2","Ba")
    
    data(blatna_iso)
    accessVar("blatna_iso")
    ageEps()
}

\references{
Janouek V, Rogers G,  Bowes DR (1995) Sr-Nd isotopic constraints on the petrogenesis of the Central 
Bohemian Pluton, Czech Republic. Geol Rundsch 84: 520-534
\doi{10.1007/BF00284518} 

Janouek V, Bowes DR, Rogers G, Farrow CM, Jelnek E (2000) Modelling diverse processes in the petrogenesis 
of a composite batholith: the Central Bohemian Pluton, Central European Hercynides. J Petrol 41: 511-543
\doi{10.1093/petrology/41.4.511} 

Janouek V, Wiegand B, k J (2010) Dating the onset of Variscan crustal exhumation in the core of 
the Bohemian Massif: new U-Pb single zircon ages from the high-K calc-alkaline granodiorites of the 
Blatn suite, Central Bohemian Plutonic Complex. J Geol Soc (London) 167: 347-360
\doi{10.1144/0016-76492009-008} 

Janouek V, Erban Kochergina YV, Andronikov A, Kusbach V (2022) 
Decoupling of Mg from Sr-Nd isotopic compositions in Variscan subduction-related plutonic rocks 
from the Bohemian Massif: implications for mantle enrichment processes and genesis of orogenic 
ultrapotassic magmatic rocks. Int J Earth Sci, in print.
}

\seealso{
    \link{data},  \link{accessVar}
}

\keyword{datasets}

\source{Vojtch Janouek, \email{vojtech.janousek@geology.cz}}
