\encoding{Windows-1250}
\name{diagramWithCircles}
\title{A diagram with circles}
\alias{diagramWithCircles}

\description{
Plots  any Figaro-compatible template as a background. 
The size and colours of the plotted circles corresponds to the selected variable. 
}

\usage{  
diagramWithCircles(zaxis = "",diagram = NULL, colour="heat.colors", 
    scaling.factor = 1, bins = NULL,ident = getOption("gcd.ident"),alpha="FF")   
}

\arguments{
\item{zaxis}{Name of the data column to determine the size/colour of the circles.}
\item{diagram}{name of diagram.}
\item{colour}{colour scheme for the circles.}
\item{scaling.factor}{a factor determine the size of the circles.}
\item{bins}{number of intervals for the legend.}
\item{ident}{Logical: should be the individual samples identified?}
\item{alpha}{hexadecimal number indicating the alpha channel (transparency).}
}

\details{
The function \code{'diagramWithCircles'} can display any single Figaro plot template
that can be plotted by \code{'plotDiagram'}, such as a classification one. 
    
If no parameter \code{'zlab'} is given, the user is prompted to specify it.

The variable is selected using the function '\code{\link{selectColumnLabel}}.

In the specification of the variable can be used also an arithmetic expression, 
see \code{\link{calcCore}} for the correct syntax.

    \if{html}{\figure{plotWithCircles2.png}} 
    \if{latex}{\figure{plotWithCircles2.png}{options: width=5.5in}} 
    
The samples to be plotted can be selected based on combination of three searching 
mechanisms (by sample name/label, range or a Boolean condition) - see \code{\link{selectSubset}} 
for details. 

The legal colour schemes are: 
    '\code{"grays","reds","blues","greens","cyans","violets","yellows"}
    '\code{"cm.colors","heat.colors","terrain.colors","topo.colors","rainbow", "jet.colors"}'.

Optionally, the colours can be made semitransparent, if hexadecimal parameter \code{'alpha'} 
is specified for the alpha channel (transparency).
} 

\section{Warning}{
This function IS NOT Figaro-compatible.
}

\value{
None.
}

\seealso{
    \link{plotWithCircles} \link{figaro} \link{plotDiagram}
}

\examples{
    data(sazava)
    accessVar("sazava")

    diagramWithCircles("SiO2",diagram="DebonPQ",colour="jet.colours",alpha="60",bins=7)
}

\keyword{hplot}
\concept{Plot}
\concept{Menu: Plots}

\author{
    Vojtch Janouek, \email{vojtech.janousek@geology.cz} 
}
