\encoding{Windows-1250}
\name{ppm2oxide}
\alias{ppm2oxide}
\title{Calculation of wt\% of the given oxide from ppm of atom}
\description{
    Recasts concentrations of a cation (in ppm) to those of the selected oxide (in wt \%). 
}

\usage{
ppm2oxide(formula,where="WR")
}

\arguments{
  \item{formula}{character: the oxide which is to be recalculated}
  \item{where}{character: a name of matrix or dataframe with the data to be recalculated}
}

\value{
    A numeric matrix with one column containing the recalculated concentrations of 
    the given oxide (in wt \%) for individual samples.
}

\seealso{
    \code{\link{oxide2ppm}}, \code{\link{oxide2oxide}}, \code{\link{molecularWeight}} 
}

\examples{
    data(sazava)
    accessVar("sazava")

    print(WR[,c("K2O","K")])
    ppm2oxide("K2O") # Calculates K2O (in wt \%) from K (in ppm)
     
    oxide2ppm("K2O") # And vice versa
}

\keyword{manip}
\concept{Calculation}

\author{Vojtch Janouek, \email{vojtech.janousek@geology.cz}}
