\encoding{Windows-1250}
\name{selectPalette}
\title{selectPalette}
\alias{selectPalette}

\description{
    Picks given number of colour shades from one of the available palettes.
}

\usage{
    selectPalette(n,colour.palette=NULL,GUI=TRUE)
}

\arguments{
    \item{n}{desired number of colours}  
    \item{colour.palette}{one of the colour palette names, see Details}
    \item{GUI}{logical; is the function called from GUI?}
}

\details{
The desired number of colours has to be given in any case.

The possible palettes are: \code{'grays','reds','blues','greens','cyans','violets','yellows'},
\code{'cm.colors','heat.colors','terrain.colors','topo.colors','rainbow'} and \code{'jet.colors'}.

Also, user-defined palette functions are supported. See Examples. 

If not specified upon function call, the colour palette can be picked from
list of available ones. Optionally (if \code{GUI = TRUE}) a chart with their preview is shown.

    \if{html}{\figure{selectPalette.png}} 
    \if{latex}{\figure{selectPalette.png}{options: width=5.5in}}
}

\value{
    Returns a matrix with a single row of hexadecimal codes. Its single value of \code{rownames} 
    represents the name of the palette selected.
}

\note{
    Note that UK spelling of "colours" in names of palettes is fixed automatically to the US "colors".
}


\seealso{
    Table of the available named plotting colours is obtained by \code{\link{showColours}}.
    
    \link{assignColLab} \link{assignColVar}  \link{diagramWithCircles}  \link{plotWithCircles} 
    \link{filledContourFig} 
}

\examples{
    selectPalette(5,"heat.colours")
    
    my.palette<-colorRampPalette(c("black", "darkgreen", "red"),space = "rgb")
    selectPalette(5,"my.palette")
}

\keyword{color}
\concept{Edit}
\concept{Plot}
\concept{Menu: Data handling}
\author{Vojtch Janouek, \email{vojtech.janousek@geology.cz}}
