\encoding{Windows-1250}
\name{strip}
\alias{strip}
\title{Statistics: Stripplot by groups}

\description{
    Stripplot for selected samples and variable, respecting the grouping.
}

\usage{
strip(xlab = "", ...)
}

\arguments{
  \item{xlab}{variable name}
  \item{...}{additional parameters to \code{\link[lattice]{stripplot}}}
}

\details{
    Stripplot shows 1D scatter plots for each of the groups, with some artificial 
    noise (jitter) added to make the individual points better visible. Stripplots 
    are a good alternative to boxplots when sample sizes are small.

    If no variable is specified as '\code{xlab}', the user can enter 
    it using the function 
    '\code{\link{selectColumnLabel}}'. 

    In the specification of the variable can be used also 
    arithmetic expressions, see 
    \code{\link{calcCore}} 
    for the correct syntax.
}

\value{
    None.
}

\seealso{
    \code{\link[lattice]{stripplot}}, \code{\link{stripBoxplot}}
}

\examples{
    data(sazava)
    accessVar("sazava")
    groupsByLabel("Intrusion")
    
    strip("(Na2O+K2O)/Al2O3",cex=2)
}

\author{Vojtch Janouek, \email{vojtech.janousek@geology.cz}}

\keyword{hplot}
\keyword{univar}
\concept{Plot}
\concept{Menu: Calculations: Statistics}
\concept{Statistics}
\concept{Grouping}
